float xGraph, yGraph, xC, yC, bezTop, bezBottom, bezWidth, bezTan;
float freq, cR, cG, cB, xP, yP, t, Xcrosshair;


void drawGraphic (float _t, float WL, float intensity)
{
  pushMatrix();
  pushStyle();

  t=map(_t,-100,100,1,0);
  xGraph=5;
  yGraph=30+15+20+Controls.height;
  xC=140;
  yC=height-120-Vsize-50; //30 eh o tamanho de Oy-   

  //println(intensity);

  bezTop=-(intensity/100)*0.9*yC;            // top of the curve parameter, in the upper right; proportional to light inensity
  bezBottom=(intensity/100)*0.3*yC;          // bottom of the curve parameter, in the lower left; abs value prpoportional to light intensity
  bezWidth= 0.9*xC;                          // curve's width parameter
  bezTan=(-90+WL*0.38)*intensity/100;           // interception with Ox parameter to set lower end's derivative

  xP=bezierPoint (bezWidth, 0, 0, -bezWidth, t);                      // bezier curve X coordinate; t is the parameter 0<t<1 along the curve
  yP=bezierPoint (bezTop, bezTop, bezBottom+bezTan, bezBottom, t);    // bezier curve Y coordinate; t is the parameter 0<t<1 along the curve
  if (yP> 0) yP=0;

  if (!help.isSelected())
  {
    translate (xGraph, yGraph);
    translate (xC, yC);

    // graph axes
    stroke(255,180);
    strokeWeight(2);
    line (-130,0,130,0);
    line (0,40,0,-yC+10);
    beginShape(TRIANGLES);    // axis arrows
    vertex (125,-3);
    vertex (130,0);
    vertex (125,3);
    vertex (3,-yC+15);
    vertex (0,-yC+10);
    vertex (-3,-yC+15);
    endShape();
    textFont (helv, 12);
    text ("Voltagem", 80, 20);
    textFont (helv, 13);
    text ("Corrente", -60,-yC+20);

    // EMF vs. current graphic
    noFill();
    cR = red(WLcor)+0;        // brightening color
    cG = green(WLcor)+0;
    cB = blue(WLcor)+0;
    if (cR>255) cR=255;
    if (cG>255) cG=255;
    if (cB>255) cB=255;

    stroke (cR, cG, cB,230);
    strokeWeight(2);
    if (sourceWL<catWL || tutOverride) bezier (bezWidth, bezTop, 0, bezTop, 0, bezBottom+bezTan, -bezWidth, bezBottom);  // draw bezier curve on photoelectric
    else                bezier (bezWidth, 0, 0, 0, 0, 0, -bezWidth, 0        );

    // SUJEIRA! CHEAT! truque barato pra nao ter que fazer outra Bezier
    if (!tutOverride) fill(10,20,30);              
    else fill (90,170,205);
    noStroke();
    rect(-130, 2, 120, 40);

    fill(255);
    //println(WL);
    if (intensity>0 && (sourceWL<catWL || tutOverride))
      text ("Vo", map (WL, 0, 200, -75, -40), 20);

    //fill(0);
    strokeWeight(1);
    stroke (255,100);                                                 // verifica se esta ocorrendoi o efeito fotoeletrico, ou este foi forçado pelo tutorial
    if (sourceWL<catWL || tutOverride)                            // check condition of photoelectric or overrides it for learning pourposes on tutorial
    {
      if (xP>0) Xcrosshair=5;
      else Xcrosshair=-5;
      line (0,yP,xP+Xcrosshair,yP);
      line (xP,0,xP,yP-5);
    }
    else ellipse (xP, 0, 8, 8);
  }

  popMatrix();
  popStyle();
}

