class Solid
{
  PGraphics layer;
  int index;
  float dimension, velocity, nextVelocity, angVelocity, x, y, z, tween, rand;
  color currentColour, nextColour;
  int currentWL, nextWL;
  char type, path;
  boolean triggered;

  float iniX, iniY, iniZ, finX, finY, finZ;
  float Xcenter, Ycenter, Zcenter, Xcoef, Ycoef, Zcoef, T;
  float efdist;

  float[] dir = new float[3];

  Solid (PGraphics _layer, float _dimension, float _tweenStep, int _index, char _type)
  {
    layer=_layer;
    dimension=_dimension;
    velocity=_tweenStep;
    nextVelocity=_tweenStep;
    angVelocity=0.06;
    type = _type;
    tween=0;
    switch (type) {
    case 'F':    // 'F' for Foton - 'l' for linear
      currentColour = convert(350, fotonAlpha); 
      path='l';
      triggered=false;
      break;      
    case 'o':    // 'o' for orbiting electron - 'e' for elliptical 
      currentColour = color(240,240,160); 
      path='e'; 
      triggered=true;
      break;
    case 'f':    // 'f' for free electron - '1' for linear
      currentColour = color(255,200,0,200); 
      path='l'; 
      break;           
    }
    x=0;
    y=0;
    z=-50;
    T=0;

    finX=0;
    finY=0;
    finZ=0;

    index=_index;
  }

  void setWL (int _wl)
  {
    nextWL=_wl;
    nextColour=convert(nextWL, 255);
  }
  void setVelocity (float _velocity)
  {
    nextVelocity = _velocity;
  }

  void setStarting (float _iniX, float _iniY, float _iniZ)
  {
    path='l';
    iniX=_iniX;
    iniY=_iniY;
    iniZ=_iniZ;
  }
  void setDir (float x, float y, float z)
  {
    unit  (x, y, z);
  }

  void elliptical2linear ()        // when foton hits electron change path to  linear to the corner
  {
    path='l';
    iniX=x;
    iniY=y;
    iniZ=z;
    unit (1,-1,-1);
    // old way of thinking
    //finX=1000;
    //finY=1000;
    //finZ=1000;
    //unit(finX-iniX, finY-iniY, finZ-iniZ);
  }

  void orbitPath (float _Xcenter, float _Ycenter, float _Zcenter, float _Xcoef, float _Ycoef, float _Zcoef)
  {
    path='e';
    Xcenter=_Xcenter;
    Ycenter=_Ycenter;
    Zcenter=_Zcenter;
    Xcoef =_Xcoef;
    Ycoef =_Ycoef;
    Zcoef =_Zcoef;
  }

  void display()
  {
    if (triggered)
    {
      layer.beginDraw();
      layer.noStroke();
      layer.lights();
      layer.pushMatrix();
      layer.translate (x,y,z);
        layer.fill(currentColour);
        layer.sphere(dimension);
        layer.fill(currentColour);
        layer.sphere(dimension);
      layer.popMatrix();
      layer.endDraw();
    }
  }


  void update ()
  {
    if (type=='F')                              // foton control
    {
      if (triggered)
      {
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        z = iniZ + tween*(dir[2]);

        if (x<-3.3*layer.height)                     // when foton exits PGraphics view
        {
          this.untrigger();                     // deactivates it
        }

        efdist = sqrt ((x-eePos[0])*(x-eePos[0])+(y-eePos[1])*(y-eePos[1])+(z-eePos[2])*(z-eePos[2]));

        //println(efdist);                                                                                    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        if ( efdist <= eelectronRad+ffotonRad )       // if foton hits electron                               // ATENCAO: colocar currentWL<catWL no primeiro ou segundo if
        {             
          if (currentWL<catWL)
          { // ***colocar indice index se for fazer mais que um eletron
            this.untrigger();                         // deactivates it
            eelectron.elliptical2linear();
          }
        }
      }
    }

    if (type=='o')                          // if it's an electron
    {
      if (triggered)
      {
        if (path=='l')                    // if electron's path is linear (electron is free)
        {

          tween += velocity;
          x = iniX + tween*(dir[0]);
          y = iniY + tween*(dir[1]);
          z = iniZ + tween*(dir[2]);

          if (x>width+electronRad)                     // when electron leaves PGraphic
          {
            reset ();                 // deactivates it
          }
        }
        if (path=='e')                    // if electron's path is eliptical (electron is orbiting)
        {
          //println(T);
          T += angVelocity;
          x = Xcenter+ Xcoef*sin(T);
          y = 1.5*layer.height- T*100;
          z = Zcenter+ Zcoef*cos(T);
        }
        if (T >= 1.35*PI)
        {
          reset();
        }
        eePos[0]=x; 
        eePos[1]=y; 
        eePos[2]=z;     // global array to be accessed by 3D foton to check collision
      }
    }
  }


  void reset ()
  {
    tween=0;
    if (type=='F')              // if particle is a foton
    {
      currentWL    = nextWL;
      currentColour= nextColour;
      velocity     = nextVelocity;
      tween=0;
      rand = random (0.5*PI, 0.9*PI);                  // position incoming foton aligned with electron path at angle=rand
      iniX = 2*layer.width;
      iniY = 1.5*layer.height- rand*100;
      iniZ = eelectron.Zcenter+ eelectron.Zcoef*cos(rand);
      unit (-1,0,0);
    }

    if (type=='o')              // if particle is an electron
    {
      path='e';
      T = 0;
    }
  }

  void unit(float x, float y, float z)            // calculates path versor to ensure equal speed
  {
    float modulo;
    modulo = sqrt(x*x+y*y+z*z);
    dir[0] = x/modulo;
    dir[1] = y/modulo;
    dir[2] = z/modulo;
  }

  void trigger ()
  {
    triggered=true;
    reset();
  }

  void untrigger ()
  {
    triggered=false;
  }

  boolean check ()
  {
    return triggered;
  }
}



void blackout ()
{
  for (int i=0; i<ffotonN; i++)
  {
    ffoton[i].untrigger();
    //ffoton[i].reset();
  }
}
