import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class P83_r6_compr extends PApplet {

PImage light, standby;
PFont verdanab, helv, arialb;

WLslider wlSource, wlCat, tutorialA, tutorialB;
Particle[] foton, electron;
GUIslider intensity, fem, tutorialC;
Button sourceMode, credits, help, tutorial, tutNext, tutPrev;
FEMindicator indicator;
Solid eelectron, eSample, fSample;
Solid[] ffoton;


PGraphics Controls, Simulation;
PGraphics Micro;

int MainMode;
int sourceWL, catWL, globalVelocity, globalUniverse;
int ControlsPG, SimPG, MicroPG;
int counter, statusIndex;
boolean fotonModeContinuous, newElectronTriggered, helpMode, creditsMode, tutWasSelected, tutOverride;
int WLcor, ControlsBG, SimBG, srcColor, gBG;

float radius, femDim;                                 // scenario float
int Ox, Oy, Hsize, Vsize, Harea, Varea;               // scenario int
float fotRad, randHeight, fotIntensity, NFtriggered;  // foton float
int fotonUniverse, fotonAlpha, FLastTrig;             // foton int
float electronRad, NET;                               // electron float
int electronUniverse, electronAlpha, ELastTrig;       // electron int
float catRad, ang, temp;                              // cathode float
int ffotonN, eelectronRad, ffotonIndex, ffotonRad;    // 3D int
float x, y, w, hmax, t0, tmax, DD_h, DD_v, DD_w;      // drop down alert float
int dropdownTrigger;                                  // drop down alert int
float hT, wT ;                                      // tutorial float
int tutorialMode, selected;                         // tutorial int
PImage tut11, tut12;


float newElectronAng;              // position for the next electron to be triggered
float aceleration;

float[] eePos=new float[3];         // global variable for electron position on 3-dimentional view
float eeRad;

float lastaction, maxtime;
boolean insuspension;


int[] XOffset=new int[3], YOffset=new int[3];

public void setup ()
{
  frameRate(25);
  smooth();
  size (945,710);
  
  //GLOBAL VARS
  MainMode=1;            // set starting to Tutorial (3) or Simulation (1);
  globalVelocity = 5;
  globalUniverse = 500;
  newElectronTriggered = false;
  dropdownTrigger = 0;
  verdanab = loadFont ("Verdana-Bold-20.vlw");
  helv = loadFont ("SansSerif.plain-20.vlw");
  arialb = loadFont ("Arial-BoldMT-20.vlw");
  
  helpMode=false;
  creditsMode=false;

  //SCENARIO
  Ox=20;  
  Oy=20;
  Hsize = 600; 
  Vsize = 420;
  Harea = 450; 
  Varea = 380; 
  radius= 20 ; 
  femDim= 50 ;
  catRad= 380; 
  ang   = 0.9f*PI/3;

  //PGRAPHICS SETUP
  ControlsPG=0;
  SimPG=1;
  MicroPG=2;
  Controls   = createGraphics (280, 470, P2D);
  Simulation = createGraphics (Hsize+50, Vsize+50, P2D);
  Micro      = createGraphics (Hsize+50, height-100-Vsize, P3D);
  ControlsBG= color(10);
  SimBG= color(10);
  gBG= color (20,80,180);

  XOffset[ControlsPG] = 5;
  YOffset[ControlsPG] = 40;
  XOffset[SimPG] = 290;
  YOffset[SimPG] = 40;
  XOffset[MicroPG] = 290;
  YOffset[MicroPG] = Vsize+95;

  // TUTORIAL
  tutorialMode=1;
  hT=640;
  wT=820;
  tut12 = loadImage ("tut_phe2.png");
  tutorialA = new WLslider (g, 600, 360, 10, 200, 'e');
  tutorialB = new WLslider (g, 340, 360, 10, 200, 'd');
  tutorialC = new GUIslider (g, wT/2-260, 280, 150, 30, 0, 100, 75, 'b');        // 'b' for black background
  selected=0;
  tutWasSelected=false;
  tutOverride=false;
  
  //Continuous LIGHT
  light = loadImage ("light.png");  

  //FOTON
  fotonModeContinuous = true;
  fotonUniverse = globalUniverse;
  fotonAlpha = 180;
  fotRad = 7;    // foton Radius
  foton = new Particle[fotonUniverse];
  for (int i=0; i<foton.length; i++)
  {
    foton[i] = new Particle (Simulation, fotRad, globalVelocity, i, 'f');
    foton[i].reset();
  }

  //ELECTRON  
  electronUniverse = globalUniverse;
  electronAlpha = 180;
  electronRad = 5;
  electron = new Particle[electronUniverse];
  for (int i=0; i<electron.length; i++)
  {
    electron[i] = new Particle (Simulation, electronRad, globalVelocity, i, 'e');
  }

  //SLIDERS
  wlSource  = new WLslider (Controls, 50, 80, 10, 200, 'e');
  wlCat     = new WLslider (Controls, 220, 80, 10, 200, 'd');
  intensity = new GUIslider (Controls, 30, 330, 150, 30,    0, 100,  0, 's');        // 's' for solid background
  fem       = new GUIslider (Controls, 30, 380, 150, 30, -100, 100, 75, 'g');        // 'g' for gradient background

  //BUTTONs
  sourceMode = new Button (Controls, XOffset[ControlsPG], YOffset[ControlsPG], 140, 445, 200, 30, "  F\u00f3tons: Modo Discreto", "  F\u00f3tons: Modo Cont\u00ednuo", color (50,50,200));
  help       = new Button (g, 0, 0, 90, 20, 140, 30, "AJUDA Desativada", "AJUDA Ativada", color (210,240,0));
  credits    = new Button (g, 0, 0, 880, 20, 100, 30, "Cr\u00e9ditos", "Voltar", color (10,240,0));
  tutorial   = new Button (g, 0, 0, 750, 20, 100, 30, "Tutorial", "Voltar", color (100,240,255));
  tutNext    = new Button (g, 0, 0,(width-wT)/2+wT-80, (height-hT)/2+hT-50, 60, 40, ">>",">>", color (200));
  tutPrev    = new Button (g, 0, 0,(width-wT)/2+80, (height-hT)/2+hT-50, 60, 40, "<<","<<", color (200));

  //FEM Indicator
  indicator = new FEMindicator (Simulation, XOffset[ControlsPG], YOffset[ControlsPG], 164, 376, color(0,40,255), color(255), color(255,40,0), 200, 47);

  //3D
  ffotonN=50;
  eelectronRad = 50;
  ffotonRad = 20;
  eelectron = new Solid (Micro, eelectronRad, 50, 1, 'o');
  eelectron.orbitPath (0, 0, 0, 400,400,400); // Center (x,y,z) Amplitude (x,y,z)
  ffoton = new Solid[ffotonN];
  for (int i=0; i<ffotonN; i++)
  {
    ffoton[i] = new Solid (Micro, ffotonRad, 25, 1, 'F');
    ffoton[i].reset();
  }
  ffotonIndex=0;
  //ffoton.linearPath (0,0,0,50,50,10);

  // DROPDOWN
  DD_h=0;          // drop down heigth
  DD_w=1;
  DD_v=0.2f;        // dropping speed
  x   =160;
  y   =10;
  w   =150;
  hmax=90;
  tmax=5000;       // show time in ms
  
  // POWER SAVER
  maxtime=120000;  // Ajuste to tempo limite para entrar no modo de espera 
  lastaction=0;
  standby = loadImage ("sdby.png"); 

  // CREDITS
  plogo = loadImage ("plogo.png");

  background (gBG);
  setText();
  drawTitle();
  
}

public void draw ()
{
  println ("("+mouseX+","+mouseY+")");
  
  
  // POWER SAVING
  if (millis()-lastaction>maxtime)
    insuspension=true;
  else
    insuspension=false;
  // ACTION in the end
    
  
  if (!tutorial.isSelected())                                  // When MAIN MODE is SIMULATION in spite of Tutorial
  {
    background(gBG);
    Simulation.background(SimBG);
    Controls.background(ControlsBG);
  
    buildScenario(Simulation);
  
    //WLcor = convert(sourceWL, fotonAlpha);
  
    wlSource.update();
    wlSource.show();                                                                    // display Source's WL slider
    sourceWL = round(map(wlSource.getVal(), 0, wlSource.GetDim('h'), 350, 780));        // updates the Source's WL slidet while gets its value
  
    intensity.update();
    intensity.show();
    fotIntensity = 100/intensity.getVal();                                              //((100-intensity.GetVal())*fotonUniverse/400)+1;
    
    wlCat.update();
    wlCat.show();
    catWL = round(map(wlCat.getVal(), 0, wlSource.GetDim('h'), 350, 780));
    srcColor = convert (catWL, 255);
  
    fem.update();
    fem.show();
    aceleration = fem.getVal()/1000;
  
    indicator.display(fem.getVal());
  
    buildAmp(Simulation);
    buildCathode(Simulation, srcColor);
    Micro.background(10);
    //Micro.background (0.3*red(srcColor), 0.3*green(srcColor), 0.3*blue(srcColor), 120);    uncomment this to see P3D background with the cathode work function energy frequency color
  
    sourceMode.display();
    help.display();
    credits.display();
    fotonModeContinuous = sourceMode.isSelected();
  
    // ====== Start - FOTON CONTROL ======
    
    if (tutWasSelected)    // if simulation has just came back from tutorial, then black 3D screen
    {
      tutOverride=false;
      blackout();
      tutWasSelected=false;
    }
    
    if (fotIntensity <1)                            // Intensity Control Discrete Mode
      foton[millis()%fotonUniverse].trigger();      // && fotIntensity < fotonUniverse/4-1
    else if (millis()%PApplet.parseInt(fotIntensity)==0 )
    {
      foton[FLastTrig].trigger();
      FLastTrig++;
    }
    if (FLastTrig>=fotonUniverse) FLastTrig=0;      // cicle thru foton objects
  
    for (int i=0; i<foton.length; i++)            // update foton position and color
    {
      foton[i].update();
      foton[i].setWL (sourceWL, fotonAlpha);
    }
  
    WLcor = convert(sourceWL, fotonAlpha);
    if (!fotonModeContinuous)                                                        // Draw light regarding foton mode
    {
      for (int i=0; i<foton.length; i++)
      {
        foton[i].display();
      }
    }
    else
    {
      drawContinuous (Simulation, 60, 12, WLcor, intensity.getVal()*2);
    }
  
    // ====== End - FOTON CONTROL ======
  
  
    //  Start - ELECTRON CONTROL ======
  
    for (int i=0; i<electron.length; i++)                  // updates and shows electron position
    {
      electron[i].update();
      electron[i].display();
    }
    // End - ELECTRON CONTROL 
  
    // ====== Start - Micro 3D CONTROL ======
  
    eelectron.update();
    eelectron.display();
    for (int i=0; i<ffotonN; i++)
    {
      ffoton[i].setWL(sourceWL);
      ffoton[i].update();
      ffoton[i].display();
    }
    //if (frameCount%5==0) ffoton[ffotonIndex].trigger();
  
    if (frameCount%PApplet.parseInt(fotIntensity*4)==0 )
    {
      ffoton[ffotonIndex].trigger();
      ffotonIndex ++;
    }
  
    //ffotonIndex ++;
    if (ffotonIndex >= ffotonN) ffotonIndex=0;
  
    //println(ffotonIndex);
      
    // ====== End - Micro 3D CONTROL ======
  
    // ====== Start - PGRAPHICS MANAGEMENT ======
  
    image (Controls, XOffset[ControlsPG], YOffset[ControlsPG]);
    image (Simulation, XOffset[SimPG], YOffset[SimPG]);
    image (Micro, XOffset[MicroPG], YOffset[MicroPG]);
  
    // ====== End - PGRAPHICS MANAGEMENT ======
  
  
    dynamicText();
    statusBox();                    // manage status box over graphic
    statusText(statusIndex);        // show text inside status box
    
    // ==== Start - STATUS BAR ====
  
    if (help.isSelected())
    {
      // ==== Start DROP DOWN ====
      if (dropdownTrigger==0)
      {
        dropdownTrigger=6;    // dropdown super activated
        DD_h=0;
      }
  
      statusIndex=0;
      if (mouseX >= XOffset[ControlsPG]+40 && mouseX <= XOffset[ControlsPG]+70 && mouseY >= YOffset[ControlsPG]+80 && mouseY <= YOffset[ControlsPG]+280)
        statusIndex=1;  // SourceWL slider
      if (mouseX >= XOffset[ControlsPG]+210 && mouseX <= XOffset[ControlsPG]+240 && mouseY >= YOffset[ControlsPG]+80 && mouseY <= YOffset[ControlsPG]+280)
        statusIndex=2;  // Cathode color WL slider
      if (mouseX >= XOffset[ControlsPG]+30 && mouseX <= XOffset[ControlsPG]+180 && mouseY >= YOffset[ControlsPG]+315 && mouseY <= YOffset[ControlsPG]+345)
        statusIndex=3; // foton intensity slider
      if (mouseX >= XOffset[ControlsPG]+30 && mouseX <= XOffset[ControlsPG]+180 && mouseY >= YOffset[ControlsPG]+365 && mouseY <= YOffset[ControlsPG]+395)
        statusIndex=4; // fem slider
      if (mouseX >= XOffset[ControlsPG]+140-100 && mouseX <= XOffset[ControlsPG]+140+100 && mouseY >= YOffset[ControlsPG]+445-15 && mouseY <= YOffset[ControlsPG]+445+15)
        statusIndex=5; // foton mode
      if (mouseX >= XOffset[SimPG]+170 && mouseX <= XOffset[SimPG]+170+200 && mouseY >= YOffset[SimPG]+416 && mouseY <= YOffset[SimPG]+416+48)
        statusIndex=6; // fem indicator
  
      temp=sqrt((mouseX-(XOffset[SimPG]+Hsize/2+20))*(mouseX-(XOffset[SimPG]+Hsize/2+20))+(mouseY-(YOffset[SimPG]+Vsize/2))*(mouseY-(YOffset[SimPG]+Vsize/2))); 
      if (temp>=170 && temp<=210)                      // nao me pergunte o porque do +20
          if ( ( mouseY-( PApplet.parseFloat(YOffset[SimPG])+Vsize/2.f ) ) / (mouseX- (PApplet.parseFloat(XOffset[SimPG])+Hsize/2.f+20.f)) >= tan(PI-ang) &&
          (mouseY- (PApplet.parseFloat(YOffset[SimPG])+Vsize/2.f)) / (mouseX- (PApplet.parseFloat(XOffset[SimPG])+Hsize/2.f+20.f) ) <= tan(PI+ang) )
          statusIndex=7;  // cathode
  
      if (temp<=20)
        statusIndex=8; // anode
      if (mouseX >= 5 && mouseX <= 285 && mouseY >= 30+15+Controls.height+20 && mouseY <= 30+15+Controls.height+height-100-Vsize)
        statusIndex=9; // graphic
      if (mouseX >= XOffset[SimPG]+Ox+Hsize/2+Harea*0.62f-40 && mouseX <= XOffset[SimPG]+Ox+Hsize/2+Harea*0.62f+40 && mouseY >= YOffset[SimPG]+Oy+Varea/2-100 && mouseY <= YOffset[SimPG]+Oy+Varea/2+20)
        statusIndex=10;  // amperimeter
      if (mouseX >= XOffset[MicroPG] && mouseX <= XOffset[MicroPG]+Micro.width && mouseY >= YOffset[MicroPG] && mouseY <= YOffset[MicroPG]+Micro.height)
        statusIndex=11; // Micro PG
    }
    else dropdownTrigger=0;
  
    drawTitle();
    help.display();
    credits.display();
    tutorial.display();
  
    if (dropdownTrigger>0)  // if dropdown is not inactive (0)
    {
      dropdownTrigger=helpDD(dropdownTrigger);
    }
    
    // ==== End - DROP DOWN ====
  
  
    // ==== End - STATUS BAR ====
  
  
    // ==== Graphic ====
  
    drawGraphic(fem.getVal(), wlSource.getVal(), intensity.getVal()); // manage graphic 
  
    // ==== Credits ====  
  
    creditsMode=credits.isSelected();
    if (creditsMode)
    {
      showCredits();
      noLoop();
    }
  }
  
  if (tutorial.isSelected())
  {
    pushMatrix();
    tutorialMode = tutorial(tutorialMode);
    tutorial.display();
    tutNext.display();
    tutPrev.display();
    popMatrix();
    tutWasSelected=true;
  }
  else tutorialMode=1; //!!!
  
  if (insuspension)
    suspend();
  
}


// POWER SAVER SUSPENSION

public void suspend()
{
  int h, w;
  float l, fontsize;
  h=320;
  w=400;
  fontsize = 20;
  
  translate ((width-w)/2, (height-h)/2);
  fill (255,225);
  rect (0,0, w, h);
  
  fill(0);
  textAlign(CENTER);
  textFont (verdanab, 20);
  text ("EM ESPERA",w/2, 45);
  image (standby, w/2-100/2, 0.2f*h);
  
  textFont (helv, fontsize);
  text ("Esta anima\u00e7\u00e3o consome recursos do seu \n"+
        "computador e entra em espera ap\u00f3s\n"+ round(maxtime/1000) + " segundos\n\n"+ 
        "Aperte qualquer tecla para continuar",w/2, 200);
  
  noLoop();
}

public void wake()
{
  insuspension=false;
  loop();
}



// MOUSE INPUT start

public void mousePressed()
{
  if (!credits.isSelected() && !tutorial.isSelected())
  {
    sourceMode.mousePressed(mouseX, mouseY);
    help.mousePressed(mouseX, mouseY);
    credits.mousePressed(mouseX, mouseY);
    tutorial.mousePressed(mouseX, mouseY);
  }
  if (tutorial.isSelected())
  {
    tutorial.mousePressed(mouseX, mouseY);
    tutNext.mousePressed(mouseX, mouseY);
    tutPrev.mousePressed(mouseX, mouseY);
  }
  
  lastaction=millis();
  if (insuspension)
    wake();
}

public void mouseReleased()
{
  if (credits.isSelected())
  {
    credits.unSelect();
    loop();
    background (gBG);
    drawTitle();
  }
  else
  {
    sourceMode.mouseReleased();
    help.mouseReleased();
    credits.mouseReleased();
    tutorial.mouseReleased();
    tutNext.mouseReleased();
    tutPrev.mouseReleased();
  }
}

// MOUSE INPUT end


// KEYBOARD IMPUT start

public void  keyPressed ()
{
  if (key=='1' || key=='z') wlSource.increment(+2);
  if (key=='7' || key=='a') wlSource.increment(-2);
  if (key=='3' || key=='x') wlCat.increment(+2);
  if (key=='9' || key=='s') wlCat.increment(-2);

  if (key=='2' || key=='c') fem.increment (-2);
  if (key=='8' || key=='v') fem.increment (+2);
  if (key=='4' || key=='d') intensity.increment (-2);
  if (key=='6' || key=='f') intensity.increment (+2);

  if (key==ENTER) sourceMode.Select();
  
  lastaction=millis();
  if (insuspension)
    wake();
}

class Button 
{
  PGraphics layer;
  float x, y; // button-centre coords
  String BText1, BText2;       // button text
  int BStateFlag;       // button state: 0 = free / 1 = selected / 2 = pressed (selected instantly)
  boolean WasBSelected;  // previous button state: false = free // true = selected
  
  float BWidth, BHeight; // button dimensions
  
  int fontsize; // calculate fontsize based on text string and internal button size
  
  float c = 2, b = 4; // arbitrary constants (b used to be 4)
  float SAlpha;

  int ContentColour, BColour;
  int shade, light, plateau, selected;
  
  float dxoffset, dyoffset; // offsets of window (layer) where button is being placed at relative to global (0,0) (TOP LEFT CORNER)
  
  Button(PGraphics _layer, float _dxoffset, float _dyoffset, float _x, float _y, 
         float _BWidth, float _BHeight, String _BText1, String _BText2, int _BColour) {
    x = _x;
    y = _y;
    BWidth = _BWidth;
    BHeight = _BHeight;
    BStateFlag = 0;      // Button is initialised as free, default behaviour.
    WasBSelected = false;  // If needed, change var after constructor function call
    BText1 = _BText1;
    BText2 = _BText2;
    layer = _layer;
    dxoffset = _dxoffset;
    dyoffset = _dyoffset;
    BColour = _BColour;
    
    SAlpha = 255;
    SetColours();
  }
  
  
  public void SetColours() {
    plateau = BColour;
    shade = lerpColor(0xff000000, BColour, 0.8f); shade = color(red(shade), green(shade), blue(shade), alpha(BColour));
    light = lerpColor(0xffFFFFFF, BColour, 0.8f); light = color(red(light), green(light), blue(light), alpha(BColour));
    selected = color(255-red(BColour), 255-green(BColour), 255-blue(BColour));
  }
  
public void DisplayColours() {
    int TMPcolour;
    
    TMPcolour = plateau;
    
    layer.fill(TMPcolour);
    layer.noStroke();
    layer.rectMode(CENTER);
    layer.rect(x, y, BWidth, BHeight);
    
    switch(BStateFlag) {
      case 0: // free
        layer.fill(light);
        break;
      case 1: // selected
        layer.fill(shade);
        break;
      case 2: // pressed
        layer.fill(lerpColor(selected, shade, 0.9f));
        break;
    }
    layer.beginShape(TRIANGLE_STRIP); // split in 2 shapes to avoid WEIRD blending effect after color change
    layer.vertex(x + BWidth/2 - b, y - BHeight/2 + b);
    layer.vertex(x + BWidth/2, y - BHeight/2);
    layer.vertex(x - BWidth/2 + b, y - BHeight/2 + b);
    layer.vertex(x - BWidth/2, y - BHeight/2);
    layer.vertex(x - BWidth/2 + b, y + BHeight/2 - b);
    layer.vertex(x - BWidth/2, y + BHeight/2);
    layer.endShape();
    
    switch(BStateFlag) {
      case 0: // free
        layer.fill(shade);
        break;
      case 1: // selected
        layer.fill(light);
        break;
      case 2: // pressed
        layer.fill(lerpColor(selected, light, 0.9f));
        break;
    }
    layer.beginShape(TRIANGLE_STRIP);
    layer.vertex(x - BWidth/2 + b, y + BHeight/2 - b);
    layer.vertex(x - BWidth/2, y + BHeight/2);
    layer.vertex(x + BWidth/2 - b, y + BHeight/2 - b);
    layer.vertex(x + BWidth/2, y + BHeight/2);
    layer.vertex(x + BWidth/2 - b, y - BHeight/2 + b);
    layer.vertex(x + BWidth/2, y - BHeight/2);
    layer.endShape();
    
    
    switch(BStateFlag) { // this is the colour of the text, left ready to be applied in text created in display, after this funciton call
      case 0: // free
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , shade, 0.2f);
        break;
      case 1: // selected
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , light, 0.2f);
        break;
      case 2: // pressed
        ContentColour = lerpColor( color((brightness(TMPcolour) > 128) ? (0) : (255)) , TMPcolour, 0.7f);
        break;
    }
  }
  
  public void display() {
    layer.pushStyle();
    DisplayColours();
    layer.fill(ContentColour);
    layer.textAlign(CENTER, CENTER);
    layer.textFont (helv, 16);
    if (isSelected())
    {
      layer.fill (255);
      layer.text(BText2, x, y);
    }
    else
      layer.text(BText1, x, y);
    layer.popStyle();
  }
  
  public void mousePressed(float mX, float mY) {
    float dx = abs(mX - (x + dxoffset));
    float dy = abs(mY - (y + dyoffset));
    //dx e dy: testar posicao do mouse pra ver se quando eh clicado estah sobre o botao
    //mouseButton: testar pra soh considerar clique com botao esquerdo (botao direito eh inocuo)
    //se clicou com o esquerdo E estah dentro da area do botao
    if (mouseButton == LEFT && dx <= BWidth/2 && dy <= BHeight/2) {
      switch(BStateFlag) {
        case 0: // se estah FREE
          BStateFlag = 2; // vai pra PRESSED
          WasBSelected = false; // e antes estava FREE
          break;
        case 1: // se estah SELECTED
          BStateFlag = 2; // vai pra PRESSED
          WasBSelected = true; // e antes estava SELECTED
          break;
      }
    }
  }
  
  public void mouseReleased() {
    //se estah PRESSED e estava FREE -> SELECTED
    //se estah PRESSED e estava SELECTED -> FREE
    if(BStateFlag == 2) {
      BStateFlag = (WasBSelected) ? (0) : (1);
    }
  }
  
  public void free() {
    WasBSelected = true;
    BStateFlag = 0;
  }
  
  public boolean isSelected() {
    if (BStateFlag == 1) return true;
    else return false;
  }
  
  public boolean wasSelected() {
    return WasBSelected;
  }
  
  public boolean isPressed() {
    if (BStateFlag == 2) return true;
    else return false;
  }
  
  public void Select() {
    BStateFlag = 1;
    WasBSelected = false;
  }
  
  public void unSelect () {
    BStateFlag = 0;
    WasBSelected = true;
  }
    
  
  public void Press() {
    BStateFlag = 2;
  }
  
  public float GetParameters(char p) {
    float TMP = 0;
    switch(p) {
      case 'x': TMP = x; break;
      case 'y': TMP = y; break;
      case 'w': TMP = BWidth; break;
      case 'h': TMP = BHeight; break;
    }
    return TMP;
  }
  
  public String GetText() {
    if (isSelected())
    return BText2;
    else
    return BText2;
  }
  
  public int GetBGColour() {
    return BColour;
  }
  
  public void SetPosition(float _x, float _y) {
    x = _x; y = _y;
  }
  
  public void SetSize(float _BWidth, float _BHeight) {
    BWidth = _BWidth; BHeight = _BHeight;
  }
  
  public void SetText(String _BText1, String _BText2) {
    BText1 = _BText1;
    BText2 = _BText2;
  }
  
  public void SetBGColour(int _BColour) {
    BColour = _BColour;
    //Update Stuff
    //SetColours();
  }
  
  public void SetWindow(PGraphics _layer, float _dxoffset, float _dyoffset) {
    dxoffset = _dxoffset; dyoffset = _dyoffset;
    if (_layer != null) layer = _layer; // flag, to only set offsets
  }
}

float xGraph, yGraph, xC, yC, bezTop, bezBottom, bezWidth, bezTan;
float freq, cR, cG, cB, xP, yP, t, Xcrosshair;


public void drawGraphic (float _t, float WL, float intensity)
{
  pushMatrix();
  pushStyle();

  t=map(_t,-100,100,1,0);
  xGraph=5;
  yGraph=30+15+20+Controls.height;
  xC=140;
  yC=height-120-Vsize-50; //30 eh o tamanho de Oy-   

  //println(intensity);

  bezTop=-(intensity/100)*0.9f*yC;            // top of the curve parameter, in the upper right; proportional to light inensity
  bezBottom=(intensity/100)*0.3f*yC;          // bottom of the curve parameter, in the lower left; abs value prpoportional to light intensity
  bezWidth= 0.9f*xC;                          // curve's width parameter
  bezTan=(-90+WL*0.38f)*intensity/100;           // interception with Ox parameter to set lower end's derivative

  xP=bezierPoint (bezWidth, 0, 0, -bezWidth, t);                      // bezier curve X coordinate; t is the parameter 0<t<1 along the curve
  yP=bezierPoint (bezTop, bezTop, bezBottom+bezTan, bezBottom, t);    // bezier curve Y coordinate; t is the parameter 0<t<1 along the curve
  if (yP> 0) yP=0;

  if (!help.isSelected())
  {
    translate (xGraph, yGraph);
    translate (xC, yC);

    // graph axes
    stroke(255,180);
    strokeWeight(2);
    line (-130,0,130,0);
    line (0,40,0,-yC+10);
    beginShape(TRIANGLES);    // axis arrows
    vertex (125,-3);
    vertex (130,0);
    vertex (125,3);
    vertex (3,-yC+15);
    vertex (0,-yC+10);
    vertex (-3,-yC+15);
    endShape();
    textFont (helv, 12);
    text ("Voltagem", 80, 20);
    textFont (helv, 13);
    text ("Corrente", -60,-yC+20);

    // EMF vs. current graphic
    noFill();
    cR = red(WLcor)+0;        // brightening color
    cG = green(WLcor)+0;
    cB = blue(WLcor)+0;
    if (cR>255) cR=255;
    if (cG>255) cG=255;
    if (cB>255) cB=255;

    stroke (cR, cG, cB,230);
    strokeWeight(2);
    if (sourceWL<catWL || tutOverride) bezier (bezWidth, bezTop, 0, bezTop, 0, bezBottom+bezTan, -bezWidth, bezBottom);  // draw bezier curve on photoelectric
    else                bezier (bezWidth, 0, 0, 0, 0, 0, -bezWidth, 0        );

    // SUJEIRA! CHEAT! truque barato pra nao ter que fazer outra Bezier
    if (!tutOverride) fill(10,20,30);              
    else fill (90,170,205);
    noStroke();
    rect(-130, 2, 120, 40);

    fill(255);
    //println(WL);
    if (intensity>0 && (sourceWL<catWL || tutOverride))
      text ("Vo", map (WL, 0, 200, -75, -40), 20);

    //fill(0);
    strokeWeight(1);
    stroke (255,100);                                                 // verifica se esta ocorrendoi o efeito fotoeletrico, ou este foi for\u00e7ado pelo tutorial
    if (sourceWL<catWL || tutOverride)                            // check condition of photoelectric or overrides it for learning pourposes on tutorial
    {
      if (xP>0) Xcrosshair=5;
      else Xcrosshair=-5;
      line (0,yP,xP+Xcrosshair,yP);
      line (xP,0,xP,yP-5);
    }
    else ellipse (xP, 0, 8, 8);
  }

  popMatrix();
  popStyle();
}

class Solid
{
  PGraphics layer;
  int index;
  float dimension, velocity, nextVelocity, angVelocity, x, y, z, tween, rand;
  int currentColour, nextColour;
  int currentWL, nextWL;
  char type, path;
  boolean triggered;

  float iniX, iniY, iniZ, finX, finY, finZ;
  float Xcenter, Ycenter, Zcenter, Xcoef, Ycoef, Zcoef, T;
  float efdist;

  float[] dir = new float[3];

  Solid (PGraphics _layer, float _dimension, float _tweenStep, int _index, char _type)
  {
    layer=_layer;
    dimension=_dimension;
    velocity=_tweenStep;
    nextVelocity=_tweenStep;
    angVelocity=0.06f;
    type = _type;
    tween=0;
    switch (type) {
    case 'F':    // 'F' for Foton - 'l' for linear
      currentColour = convert(350, fotonAlpha); 
      path='l';
      triggered=false;
      break;      
    case 'o':    // 'o' for orbiting electron - 'e' for elliptical 
      currentColour = color(240,240,160); 
      path='e'; 
      triggered=true;
      break;
    case 'f':    // 'f' for free electron - '1' for linear
      currentColour = color(255,200,0,200); 
      path='l'; 
      break;           
    }
    x=0;
    y=0;
    z=-50;
    T=0;

    finX=0;
    finY=0;
    finZ=0;

    index=_index;
  }

  public void setWL (int _wl)
  {
    nextWL=_wl;
    nextColour=convert(nextWL, 255);
  }
  public void setVelocity (float _velocity)
  {
    nextVelocity = _velocity;
  }

  public void setStarting (float _iniX, float _iniY, float _iniZ)
  {
    path='l';
    iniX=_iniX;
    iniY=_iniY;
    iniZ=_iniZ;
  }
  public void setDir (float x, float y, float z)
  {
    unit  (x, y, z);
  }

  public void elliptical2linear ()        // when foton hits electron change path to  linear to the corner
  {
    path='l';
    iniX=x;
    iniY=y;
    iniZ=z;
    unit (1,-1,-1);
    // old way of thinking
    //finX=1000;
    //finY=1000;
    //finZ=1000;
    //unit(finX-iniX, finY-iniY, finZ-iniZ);
  }

  public void orbitPath (float _Xcenter, float _Ycenter, float _Zcenter, float _Xcoef, float _Ycoef, float _Zcoef)
  {
    path='e';
    Xcenter=_Xcenter;
    Ycenter=_Ycenter;
    Zcenter=_Zcenter;
    Xcoef =_Xcoef;
    Ycoef =_Ycoef;
    Zcoef =_Zcoef;
  }

  public void display()
  {
    if (triggered)
    {
      layer.beginDraw();
      layer.noStroke();
      layer.lights();
      layer.pushMatrix();
      layer.translate (x,y,z);
        layer.fill(currentColour);
        layer.sphere(dimension);
        layer.fill(currentColour);
        layer.sphere(dimension);
      layer.popMatrix();
      layer.endDraw();
    }
  }


  public void update ()
  {
    if (type=='F')                              // foton control
    {
      if (triggered)
      {
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        z = iniZ + tween*(dir[2]);

        if (x<-3.3f*layer.height)                     // when foton exits PGraphics view
        {
          this.untrigger();                     // deactivates it
        }

        efdist = sqrt ((x-eePos[0])*(x-eePos[0])+(y-eePos[1])*(y-eePos[1])+(z-eePos[2])*(z-eePos[2]));

        //println(efdist);                                                                                    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        if ( efdist <= eelectronRad+ffotonRad )       // if foton hits electron                               // ATENCAO: colocar currentWL<catWL no primeiro ou segundo if
        {             
          if (currentWL<catWL)
          { // ***colocar indice index se for fazer mais que um eletron
            this.untrigger();                         // deactivates it
            eelectron.elliptical2linear();
          }
        }
      }
    }

    if (type=='o')                          // if it's an electron
    {
      if (triggered)
      {
        if (path=='l')                    // if electron's path is linear (electron is free)
        {

          tween += velocity;
          x = iniX + tween*(dir[0]);
          y = iniY + tween*(dir[1]);
          z = iniZ + tween*(dir[2]);

          if (x>width+electronRad)                     // when electron leaves PGraphic
          {
            reset ();                 // deactivates it
          }
        }
        if (path=='e')                    // if electron's path is eliptical (electron is orbiting)
        {
          //println(T);
          T += angVelocity;
          x = Xcenter+ Xcoef*sin(T);
          y = 1.5f*layer.height- T*100;
          z = Zcenter+ Zcoef*cos(T);
        }
        if (T >= 1.35f*PI)
        {
          reset();
        }
        eePos[0]=x; 
        eePos[1]=y; 
        eePos[2]=z;     // global array to be accessed by 3D foton to check collision
      }
    }
  }


  public void reset ()
  {
    tween=0;
    if (type=='F')              // if particle is a foton
    {
      currentWL    = nextWL;
      currentColour= nextColour;
      velocity     = nextVelocity;
      tween=0;
      rand = random (0.5f*PI, 0.9f*PI);                  // position incoming foton aligned with electron path at angle=rand
      iniX = 2*layer.width;
      iniY = 1.5f*layer.height- rand*100;
      iniZ = eelectron.Zcenter+ eelectron.Zcoef*cos(rand);
      unit (-1,0,0);
    }

    if (type=='o')              // if particle is an electron
    {
      path='e';
      T = 0;
    }
  }

  public void unit(float x, float y, float z)            // calculates path versor to ensure equal speed
  {
    float modulo;
    modulo = sqrt(x*x+y*y+z*z);
    dir[0] = x/modulo;
    dir[1] = y/modulo;
    dir[2] = z/modulo;
  }

  public void trigger ()
  {
    triggered=true;
    reset();
  }

  public void untrigger ()
  {
    triggered=false;
  }

  public boolean check ()
  {
    return triggered;
  }
}



public void blackout ()
{
  for (int i=0; i<ffotonN; i++)
  {
    ffoton[i].untrigger();
    //ffoton[i].reset();
  }
}
class Particle
{
  float iniX, iniY, finX, finY, radius, velocity, nextVelocity, x, y;
  float tween, rand, eAng, edgeRad;
  int index;
  int currentColour,nextColour;
  int currentWL, nextWL;
  boolean triggered;
  PGraphics layer;
  char type;
  
  float acel, maxVel;
  
  Particle (PGraphics _layer, float _radius, float _tweenStep, int _index, char _type)
  {
    layer=_layer;
    radius=_radius;
    velocity=_tweenStep;
    nextVelocity=_tweenStep;
    type = _type;
    tween=0;
    edgeRad=catRad-40;
    switch (type){
    case 'f': currentColour = convert(350, fotonAlpha); break;
    case 'e': currentColour = color(240,240,160); break;
    }
    x=0;
    y=0;

    index=_index;
    triggered=false;
    maxVel=5;                        // TO BE CHANGED
  }
  
  public void setWL (int _wl, int fAlpha)
  {
    nextWL=_wl;
    nextColour=convert(nextWL, fAlpha);
  }
  public void setWL (int _wl)
  {
    nextWL=_wl;
  }
  
  public void setVelocity (float _velocity)
  {
    nextVelocity = _velocity;
  }
  
  public void setPath (float _iniX, float _iniY, float _finX, float _finY)
  {
    iniX=_iniX;
    iniY=_iniY;
    finX=_finX;
    finY=_finY;
  }
  
  
  public void setAngle (float _eAng)
  {
    eAng=_eAng;
  }
  
  public void setIndex (int ind)
  {
    index = ind;
  }
  
  public void display()
  {
    if (triggered)
    {
      layer.fill (currentColour);
      
      layer.pushMatrix();
      layer.pushStyle();
      layer.noStroke();    
      layer.beginDraw();
      
      layer.translate (x, y);
      //layer.stroke(0,80);
      layer.ellipse (0,0, radius, radius);
      
      layer.endDraw();
      layer.popMatrix();
      layer.popStyle();
    }
    
  }
  
  public void update ()
  {
    if (type=='f')
    {
      if (triggered)
      {
        float[] dir = new float[2];
        unit(finX-iniX, finY-iniY, dir);
        
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        
        if (x<finX && x!=0)                     // when foton arrives to the cathode
        {
          this.untrigger();                 // deactivates it
          if (currentWL<catWL)
          {
            electron[index].setAngle(rand);
            electron[index].setWL(currentWL);
            electron[index].trigger();        // activates corresponding electron
          }
        }
      }
    }
    
    if (type=='e')
    {
      if (triggered)
      {
        float[] dir = new float[2];
        unit(finX-iniX, finY-iniY, dir);
        
        
        velocity += aceleration;  
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        
        if (x>finX)                     // when electron arrives to the cathode
        {
          untrigger ();                 // deactivates it
        }
        if (x<iniX)
        {
          untrigger ();
        }
      }
    }
  }
  
  public void reset ()
  {
    x=0;y=0;
    if (type=='f')              // if particle is a foton
    {
      currentWL    = nextWL;
      currentColour= nextColour;
      velocity     = nextVelocity;
      tween=0;
      rand = random (PI-ang, PI+ang);
      iniX = Ox+0.8f*Hsize;
      iniY = Oy+Varea/2+edgeRad*sin(rand)/2;
      finX = Ox+Hsize/2+edgeRad*cos(rand)/2;
      finY = Oy+Varea/2+edgeRad*sin(rand)/2;
    }
    
    if (type=='e')              // if particle is a foton
    {
      //currentColour= nextColour;
      
      //println(nextWL);
      maxVel = map (nextWL, 350, 780, 4.9f, 3);
      
      // set initial kinetic energy K = hf-<work function>
      if (index%10==0)
      velocity = maxVel;
      else                            // ensure at least 10% have maximum kinetic energy to create remarkable visual effect
      velocity = random (maxVel/2,maxVel);
      
      tween=0;
      iniX = Ox+Hsize/2+edgeRad*cos(eAng)/2;
      iniY = Oy+Varea/2+edgeRad*sin(eAng)/2;
      finX = Ox+Hsize/2;
      finY = Oy+Varea/2;
    }  
        
  }  
  
  public void trigger ()
  {
    if (type=='f') NFtriggered ++;
    if (type=='e') NET++;
    triggered=true;
    reset();
  }
  
  public void untrigger ()
  {
    if (type=='f') NFtriggered --;
    if (type=='e') NET --;
    triggered=false;
  }
    
  public boolean check ()
  {
  return triggered;
  }

}

public void unit(float x, float y, float[] direction)            // calculates path versor to ensure equal speed
{
  float modulo;
  modulo = sqrt(x*x+y*y);
  direction[0] = x/modulo;
  direction[1] = y/modulo;
}

public void drawContinuous (PGraphics layer, float dx, float dy, int rawcolour, float colouralpha)        // generates continous light mask
{
  
  layer.tint (rawcolour, colouralpha); 
  layer.beginDraw();
  layer.image (light, dx, dy);
  layer.endDraw();
  layer.noTint();
}

    
    
// in Public: DROP DOWN | WL CONVERT FUNCTION | NONE LOCKED | ROUNDED EDGES RECTANGLE

public int helpDD (int phase)
{  
  pushStyle();
  noStroke();
  fill(150,235,0);
  if (phase==6)
  {
    DD_w=0;
    DD_h=0;
    phase=5;
  }
  if (phase==5)
  {
    roundRect (x, y, DD_w, 0);
    DD_w+=DD_v*(w-DD_w);
    if (DD_w>=w-1) phase=4;
  }
  if (phase==4)
  {
    roundRect (x, y, w, DD_h);
    DD_h+=DD_v*(hmax-DD_h);
    if (DD_h>=hmax-1)
    {
      phase=3;
      t0=millis();
    }
  }
  if (phase==3)
  {
    roundRect (x, y, w, DD_h);
    textFont (helv, 14);
    fill(0);
    text ("Dica: O menu\nAJUDA INTERATIVA\naparece no campo\ninferior esquerdo da\ntela da anima\u00e7\u00e3o.",x+3, y+15);
    if ((millis()-t0)>tmax) phase=2;
  }
  if (phase==2)
  {
    roundRect (x, y, w, DD_h);
    DD_h-=DD_v*(DD_h);
    if (DD_h<0+1) phase=1;
  }
  if (phase==1)
  {
    roundRect (x, y, DD_w, 0);
    DD_w-=DD_v*(DD_w);
    if (DD_w<0+1) phase=-1;    // will be set to 0 when help mode is deactivated
  }
  popStyle();
  return phase;
}


public boolean noneLocked ()
{
  return (!wlSource.isLocked() && !wlCat.isLocked() && !intensity.isLocked() && !fem.isLocked());
}

public int convert (int Wavelength, int alphaset)
{
  float Gamma = 1.00f;
  int IntensityMax = 255;
  float Blue, Green, Red;
  float Factor;
  
  int WLcor;
  
  if(Wavelength >= 350 && Wavelength <= 439)
  {
    Red	= map (Wavelength, 350, 440, 255, 0);
    Green = 0;
    Blue	= 255;
  }
  else if(Wavelength >= 440 && Wavelength <= 489)
  {
    Red	= 0;
    Green = map(Wavelength, 440, 490, 0, 255);
    Blue	= 255;
  }
  else if(Wavelength >= 490 && Wavelength <= 509)
  {
    Red = 0;
    Green = 255;
    Blue = map(Wavelength, 490, 510, 255, 0);
  }
  else if(Wavelength >= 510 && Wavelength <= 579)
  { 
    Red = map(Wavelength, 510, 580, 0, 255);
    Green = 255;
    Blue = 0;
  }
  else if(Wavelength >= 580 && Wavelength <= 644)
  {
    Red = 255;
    Green = map(Wavelength, 580, 645, 255, 0);
    Blue = 0.0f;
  }
  else if(Wavelength >= 645 && Wavelength <= 780)
  {
    Red = 255;
    Green = 0.0f;
    Blue = 0.0f;
  }
  else
  {
    Red = 0.0f;
    Green = 0.0f;
    Blue = 0.0f;
  }
  if(Wavelength >= 350 && Wavelength <= 419)
    Factor = 0.3f + 0.7f*(Wavelength - 350) / (420 - 350);
  else if(Wavelength >= 420 && Wavelength <= 700)
    Factor = 1.0f;
  else if(Wavelength >= 701 && Wavelength <= 780)
    Factor = 0.3f + 0.7f*(780 - Wavelength) / (780 - 700);
  else
   Factor = 0.0f;

  WLcor = color(round(Red*Factor), round(Green*Factor), round(Blue*Factor), alphaset);
  return WLcor;
}

public void roundRect(float x, float y, float w, float h)
{
  rectMode(CORNER);

  float  ax, ay, hr, r;
  r=10;
  ax=x+w-1;
  ay=y+h-1;
  hr = r/2;

  rect(x, y, w, h);
  arc(x, y, r, r, radians(180.0f), radians(270.0f));
  arc(ax, y, r,r, radians(270.0f), radians(360.0f));
  arc(x, ay, r,r, radians(90.0f), radians(180.0f));
  arc(ax, ay, r,r, radians(0.0f), radians(90.0f));
  rect(x, y-hr, w, hr);
  rect(x-hr, y, hr, h);
  rect(x, y+h, w, hr);
  rect(x+w,y,hr, h);
} 


public void buildScenario (PGraphics layer)
{
  float areaOffset=5;

  layer.background (SimBG);
  layer.fill(0);

  layer.beginDraw();

  layer.pushMatrix();
  layer.pushStyle();
  layer.translate(Ox, Oy);

  layer.noFill();
  layer.stroke(255);
  layer.strokeWeight(2);

  layer.beginShape();                                              // circuit
  layer.vertex(Hsize/2-Harea/2, Varea/2);
  layer.vertex(radius, Varea/2);
  layer.bezierVertex(0, Varea/2, 0, Varea/2, 0, Varea/2+radius);
  layer.vertex(0, Vsize-radius);
  layer.bezierVertex(0, Vsize, 0, Vsize, radius, Vsize);
  layer.vertex (Hsize-radius, Vsize);
  layer.bezierVertex(Hsize, Vsize, Hsize, Vsize, Hsize, Vsize-radius);
  layer.vertex (Hsize, Varea/2+radius);
  layer.bezierVertex (Hsize, Varea/2, Hsize, Varea/2, Hsize-radius, Varea/2);
  layer.vertex(Hsize/2+Harea/2, Varea/2);
  layer.endShape();


  layer.fill (160,220,255);
  layer.rect (Hsize/2-Harea/2, 0, Harea, Varea);                  // test area
  layer.fill (SimBG);
  layer.rect (Hsize/2-Harea/2+areaOffset, +areaOffset, Harea-2*areaOffset, Varea-2*areaOffset);



  // generator
  layer.pushStyle();
  layer.fill(SimBG);
  layer.rect(Hsize/4, Vsize-femDim/2, 4*femDim, femDim);
  layer.popStyle();
  //layer.line(0.25*Hsize, Vsize-0.7*femDim, 0.25*Hsize, Vsize+0.7*femDim);
  //layer.line(0.25*Hsize+0.16*femDim, Vsize-femDim, 0.25*Hsize+0.16*femDim, Vsize+femDim);
  //layer.line(0.25*Hsize+0.5*femDim, Vsize-1.2*femDim, 0.25*Hsize+0.5*femDim, Vsize-0.8*femDim);
  //layer.line(0.25*Hsize+0.3*femDim, Vsize-femDim, 0.25*Hsize+0.7*femDim, Vsize-femDim);

  layer.line(Hsize/2-Harea/2, Varea/2, Hsize/2, Varea/2);                // cathode wire
  layer.line(Hsize/2+Harea/2, Varea/2, Hsize/2, Varea/2);                // anode wire


  layer.popStyle();
  layer.popMatrix();
  layer.endDraw();
}

public void buildCathode (PGraphics layer, int colour)
{  
  layer.pushMatrix();
  layer.translate (Ox, Oy);
  layer.translate (Hsize/2, Varea/2);
  layer.pushStyle();
  layer.fill(150);                                            // change the parameter to "colour" to show the current selected color on the emitter
  layer.arc (0,0, 1.1f*catRad, 1.1f*catRad, PI-ang, PI+ang);
  layer.fill(SimBG);
  layer.arc (0,0, 0.9f*catRad, 0.9f*catRad, PI-ang, PI+ang);
  layer.pushMatrix();
  layer.rotate (-0.01f);
  layer.line(catRad/2*1.1f*cos(PI-ang), catRad/2*1.1f*sin(PI-ang), catRad/2*0.9f*cos(PI-ang), catRad/2*0.9f*sin(PI-ang));
  layer.line(catRad/2*1.1f*cos(PI+ang), catRad/2*1.1f*sin(PI+ang), catRad/2*0.9f*cos(PI+ang), catRad/2*0.9f*sin(PI+ang));
  layer.fill (255);
  layer.strokeWeight(2);
  layer.ellipse(0, 0, 10, 10);                                                  // anode
  layer.popMatrix();
  
  layer.fill (colour);
  layer.stroke(150);
  layer.strokeWeight(2);
  layer.ellipse (-175, 130, 50, 50); 
  
  layer.popStyle();
  layer.popMatrix();
}

public void buildAmp (PGraphics layer)
{
  float I;
  layer.pushMatrix();
  layer.pushStyle();
  layer.noStroke();
  layer.translate (Ox, Oy);
  layer.translate (Hsize/2, Varea/2);
  layer.translate (Harea*0.62f,0);
  layer.rectMode(CENTER);
  layer.fill(0,100,255);
  layer.rect (0,-40,80,120);
  layer.fill(255);
  layer.rect (0,-55,70,80);
  layer.fill(0);
  layer.translate(0,-25);
  layer.ellipse (0,0,4,4);
  layer.noFill();
  layer.stroke(0);
  layer.arc (0,0,80,80,5*PI/4, 7*PI/4);


  I=bezierPoint (bezTop, bezTop, bezBottom+bezTan, bezBottom, t);        // amperimeter indication follows graphic Y-value
  if (I>0) I=0;
  I=map(I, 36, -108, 5*PI/4, 3*PI/4);                                    // 36=min bezBottom and -108=max bezBottom   NOTE: see opposite values *(-1)
  if (sourceWL<catWL) layer.line (0,0, 48*sin(I), 48*cos(I));            // draw indicator if Photoeletric Effect is going on
  else                layer.line (0,0, 48*sin(9*PI/8), 48*cos(9*PI/8));  // zero current if Photoeletric Effect isn't happening


  layer.line (40*sin(5*PI/4), 40*cos(5*PI/4), 48*sin(5*PI/4), 48*cos(5*PI/4));    // minimum mark
  layer.line (40*sin(3*PI/4), 40*cos(3*PI/4), 48*sin(3*PI/4), 48*cos(3*PI/4));    // maximum mark
  layer.stroke (0,0,255);
  layer.fill (0,0,255);
  layer.line (40*sin(9*PI/8), 40*cos(9*PI/8), 48*sin(9*PI/8), 48*cos(9*PI/8));    // ZERO mark
  layer.textFont (helv, 8);
  layer.text ("0",  55*sin(9*PI/8), 55*cos(9*PI/8));                              // ZERO indication
  layer.textFont (verdanab, 10);
  layer.fill (255,0,0);
  layer.text ("+",  -5+30*sin(3*PI/4), 30*cos(3*PI/4));                           // Positive side
  layer.fill (0);
  layer.text ("-",  30*sin(5*PI/4), 30*cos(5*PI/4));                              // Negative side

  layer.textFont (helv, 13);
  layer.fill(255);
  layer.text ("Amper\u00edmetro",-36,30);



  layer.popStyle();
  layer.popMatrix();
}

class FEMindicator
{
  PGraphics layer;
  float anchorX, anchorY, x, y, index;
  int[] leftGrad, rightGrad;
  int left, center, right;
  int IWidth, IHeight, pc;

  FEMindicator (PGraphics _layer, float _anchorX, float _anchorY, float _x, float _y, int left, int center, int right, int _IWidth, int _IHeight)
  {
    layer=_layer;
    IWidth =_IWidth;
    IHeight=_IHeight;
    anchorX =_anchorX;
    anchorY =_anchorY;
    x=_x;
    y=_y;

    leftGrad  = new int[IWidth/2];
    rightGrad = new int[IWidth/2];
    setColors (left, center, right);
  }

  public void setColors (int left, int center, int right)
  {
    for (int i=0; i<IWidth/2; i++)
    {
      index = PApplet.parseFloat(i+30)/PApplet.parseFloat(IWidth/2);
      index = constrain (index, 0, 1);
      leftGrad[i]  = lerpColor (center, left, index);
      rightGrad[i] = lerpColor (center, right, index);
      //println(index);
    }
  }

  public void display (float percentage)
  {
    layer.pushMatrix();
    layer.pushStyle();

    percentage = constrain (percentage, -100, 100);
    layer.translate (anchorX+x+IWidth/2, anchorY+y);
    layer.fill(255);
    layer.textFont (verdanab, 20);

    if (percentage==0) 
    {
      layer.stroke(255);
      layer.line(0,0,0,IHeight);
    }
    if (percentage>0)
    {
      for(int i=0; i<(percentage/100*(IWidth/2)); i++)
      {
        layer.stroke (rightGrad[i]);
        layer.line(i,0,i,IHeight);
      }
      
      layer.text ("+",IWidth/2-22,IHeight/2+8);
    }
    if (percentage<0)
    {
      for(int i=0; i<(abs(percentage)/100*(IWidth/2)); i++)
      {
        layer.stroke (leftGrad[i]);
        layer.line(-i,0,-i,IHeight);
      }
      layer.text ("+",-IWidth/2+6, IHeight/2+8);
    }
    layer.popMatrix();
    layer.popStyle();
  }
}




  // =====================================================  GUI SLIDER  ============================================================= 
 
class GUIslider        // normal slider 
{
  float XOff, YOff, anchorX, anchorY, LGauge, WGauge, spos, Rmin, Rmax, stdSpos;
  int value, SWidth, SHeight;
  int trackC, gaugeC;
  
  float[] aux;
  int[] palette;
  int wl;
  PGraphics layer;
  boolean over;           // mouse over slider
  boolean locked;
  char bgType;
  
  GUIslider (PGraphics _layer, float _anchorX, float _anchorY, int _SWidth, int _SHeight, float _Rmin, float _Rmax, float _spos, char _type)
  {
    layer   =_layer;
    anchorX =_anchorX;
    anchorY =_anchorY;
    SWidth  =_SWidth;
    SHeight =_SHeight;
    LGauge  = (SWidth<SHeight) ? SWidth : 5;           //gauge vertical dimension
    WGauge  = (SWidth<SHeight) ? 5 : SHeight;            //gauge horizontal dimension
    Rmin    = _Rmin;
    Rmax    = _Rmax;
    spos    = _spos;
    stdSpos = SWidth/2;
    bgType  = _type;
    
    gaugeC = color(200);
    if(bgType=='s')
    trackC = color(150);
    if(bgType=='b')
    trackC = color(50);
    else  // meaning bgType='g'
    trackC = color (150);          // obviamente mudara, ATENCAO AQUI
    
    if (layer==Controls)
    {
      XOff=XOffset[ControlsPG];
      YOff=YOffset[ControlsPG];
    }
    else
    XOff=YOff=0;
    
  }
  
  public void show ()
  {
    layer.beginDraw();
    layer.pushMatrix();
    layer.translate (anchorX, anchorY);
    layer.pushStyle();
    
    layer.strokeWeight(4);
    layer.stroke(255);
    layer.line(0, 0, (SWidth>SHeight) ? SWidth : 0, (SWidth>SHeight) ? 0 : SHeight);
    
    layer.strokeWeight(2);
    layer.stroke(trackC);
    layer.line(0, 0, (SWidth>SHeight) ? SWidth : 0, (SWidth>SHeight) ? 0 : SHeight);
    
    
    layer.strokeWeight (1);
    layer.stroke(255);
    if (SWidth>SHeight)
    {layer.line (0, -0.25f*SHeight, 0, 0.25f*SHeight); layer.line (SWidth, -0.25f*SHeight, SWidth, 0.25f*SHeight); layer.line (SWidth/2, -0.25f*SHeight, SWidth/2, 0.25f*SHeight);}
    else
    {layer.line (0, -0.25f*SWidth, 0, 0.25f*SWidth); layer.line (SHeight, -0.25f*SWidth, SHeight, 0.25f*SWidth); layer.line (SHeight/2, -0.25f*SWidth, SHeight/2, 0.25f*SWidth);}
    
    if (SWidth<SHeight) layer.translate (0, spos);
    else layer.translate (spos, 0);
    layer.stroke(0);
    layer.strokeWeight(1);
    layer.strokeJoin(ROUND);
    layer.fill(gaugeC);
    layer.beginShape();
    layer.vertex ( LGauge/2, WGauge/2);
    layer.vertex ( LGauge/2,-WGauge/2);
    layer.vertex (-LGauge/2,-WGauge/2);
    layer.vertex (-LGauge/2, WGauge/2);
    layer.endShape(CLOSE);
    layer.popStyle();
    layer.popMatrix();
    layer.endDraw();
    
    
  }
  
  
  public void update() 
  {
 
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }

    if(mousePressed && over && noneLocked()) 
    {
      if (mouseButton == LEFT) locked = true;
      if (mouseButton == RIGHT) spos=stdSpos;
    }
    
    if(!mousePressed) 
    {
      locked = false;
    }
    
    if (locked && SWidth<SHeight)
    {
      spos = (mouseY-anchorY-YOff);
      if (spos<0) spos=0;
      if (spos>SHeight) spos=SHeight;
    }
    if (locked && SWidth>SHeight)
    {
      spos = (mouseX-anchorX-XOff);
      if (spos<0) spos=0;
      if (spos>SWidth) spos=SWidth;
    }

  }
  
  public boolean isLocked()
  {
    return locked;
  }  
  
  public float getVal ()
  {
    return map(spos, 0, (SWidth>SHeight) ? SWidth : SHeight, Rmin, Rmax);
  }
  
  
  public boolean over() 
  {
    if( SWidth<SHeight &&
       mouseX > XOff+anchorX-SWidth/2 && mouseX < XOff+anchorX+SWidth/2 &&
       mouseY > YOff+anchorY && mouseY < YOff+anchorY+SHeight) 
      return true;
    else 
    if ( SWidth>SHeight &&
       mouseX > XOff+anchorX && mouseX < XOff+anchorX+SWidth &&
       mouseY > YOff+anchorY-SHeight/2 && mouseY < YOff+anchorY+SHeight/2) 
      return true;
      
    else
      return false;
  }
  
  public int GetDim (char x)
  {
  int dim=0;
  if (x=='h' || x=='w') dim = (x=='h') ?  SHeight : SWidth;
  return dim;
  }
  
  public boolean increment (float val)
  {
    if (spos+val >= 0 && spos+val <= SWidth)
    {
      spos +=val;
      return true;
    }
    return false;
  }
} 
  
  // =====================================================  WL SLIDER =============================================================
  
class WLslider  // wavelength slider 
{
  float XOff, YOff, anchorX, anchorY, tri_side, spos;
  int value, SWidth, SHeight;
  
  float[] aux;
  int[] palette;
  int wl;
  PGraphics layer;
  boolean over;           // mouse over slider
  boolean locked;
  char side;
  
  WLslider (PGraphics _layer, float _anchorX, float _anchorY, int _SWidth, int _SHeight, char _side)
  {
    layer=_layer;
    anchorX=_anchorX;
    anchorY=_anchorY;
    SWidth=_SWidth;
    SHeight=_SHeight;
    palette = new int[SHeight+1];
    aux = new float [SHeight+1];
    for (int j=0; j<SHeight; j++)
      {
        wl = (int)(map(j, 0, SHeight, 350, 780));
        palette[j] = convert (wl, 255);
      }
    tri_side = 1.2f*SWidth;
    side=_side;
    
    if (layer==Controls)
    {
      XOff=XOffset[ControlsPG];
      YOff=YOffset[ControlsPG];
    }
    else
    XOff=YOff=0;
      
  }
  
  public void show ()
  {
    
    layer.beginDraw();
    layer.pushMatrix();
    layer.pushStyle();
    
    
    layer.translate (anchorX, anchorY);
    layer.rect(0, 0, SWidth, SHeight);
    for (int i=0; i<SHeight; i++)
    {
      layer.stroke(palette[i]);
      layer.line (1, i, SWidth-1, i);
    }
    
    layer.translate (0, spos);
    layer.stroke(255);
    layer.strokeWeight(1);
    layer.fill(100);
    //layer.fill(palette[int(spos)]);
    
    if (side=='e')
    {
      layer.beginShape(TRIANGLES);
      layer.vertex (0, 0);
      layer.vertex (-tri_side*sqrt(3)/2, -tri_side/2);
      layer.vertex (-tri_side*sqrt(3)/2, +tri_side/2);
      layer.endShape(CLOSE);
    }
    if (side=='d')
    { 
      layer.translate(SWidth,0);
      layer.beginShape(TRIANGLES);
      layer.vertex (0, 0);
      layer.vertex (tri_side*sqrt(3)/2, -tri_side/2);
      layer.vertex (tri_side*sqrt(3)/2, +tri_side/2);
      layer.endShape(CLOSE);
    }
      
    
    layer.popMatrix();
    layer.popStyle();
    layer.endDraw();
  }
  
  public void update() 
  {
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }
    if(mousePressed && over && noneLocked()) 
    {
      if (mouseButton == LEFT) locked = true;
      if (mouseButton == RIGHT) spos=0;
    }
    if(!mousePressed) {
      locked = false;
    }
    
    if (locked)
    {
      spos = (mouseY-anchorY-YOff);
      if (spos<0) spos=0;
      if (spos>SHeight) spos=SHeight;
    }
  }
  
  public boolean isLocked()
  {
    return locked;
  }  
  
  public float getVal ()
  {
    return (spos);
  }
    

  
  public boolean over() 
  {
    if(mouseX > XOff+anchorX && mouseX < XOff+anchorX+SWidth &&
      mouseY > YOff+anchorY && mouseY < YOff+anchorY+SHeight) {
      return true;
    } 
    else {
      return false;
    }
  }
  
  
  public int GetDim (char x)
  {
  int dim=0;
  if (x=='h' || x=='w') dim = (x=='h') ?  SHeight : SWidth;
  return dim;
  }
  
  public boolean increment (float val)
  {
    if (spos+val >= 0 && spos+val <= SHeight)
    {
      spos +=val;
      return true;
    }
    return false;
  }
  
  public void setVal (float val)
  {
    spos = map (val, 0, 100, 0, SHeight);
  }  
}
String title;
String[] wlSlider=new String[2], hSlider=new String[2];

public void setText()
{
  title = "Efeito Fotoel\u00e9trico";
  wlSlider[0] = "Seletor da\nFun\u00e7\u00e3o Trabalho\ndo Emissor";
  wlSlider[1] = "Seletor de\nCor da Fonte\nLuminosa";
  hSlider[0] = "Intensidade \nLuminosa";
  hSlider[1] = "FEM aplicada";
}

public void dynamicText()
{
  fill(255);
  drawLabels();
}

public void drawTitle()
{
  pushStyle();
  textFont (verdanab, 20);
  noStroke();
  fill (255);
  rect (5, 5, width-10, 30);
  //textSize(20);
  fill (0,15,210);
  text (title, 370, 30);
  popStyle();
}

public void drawLabels()
{
  stroke(255);
  fill(255);
  for (int i=0; i<40; i++)
  {
    line (140, 120+5*i, 140, 121+5*i);
    if (i%5==0) line (135, 120+5*i, 145, 120+5*i);
  }
  line (135,320,145,320);
  pushStyle();
  textFont (helv, 14);
  textAlign(CENTER);
  text (wlSlider[0], 220,70);
  text (wlSlider[1], 60,70);
  textAlign(LEFT);
  text (hSlider[0], 198, 370);
  text (hSlider[1], 198, 425);
  textFont (helv, 12);
  text ("400THz", 92, 325);
  text ("790THz", 92, 125);
  text ("1,65eV", 150, 325);
  text ("3,30eV", 150, 125);
  pushMatrix();
  translate (120,286);
  rotate (-PI/2);
  textFont (verdanab, 12);
  text("FREQUENCIA",20,0);
  text("ENERGIA",35,50);
  popMatrix();
  text("0", 30,350);              // intensity scale labels
  text("100%", 170,350);
  text("-100%", 15,450);          // voltage scale labels
  text("100%", 170,450);
  text("0", 106,450);
  
  fill (240,240,160);
  stroke(240,240,160,180);
  ellipse (320,680,25,25);
  noStroke();
  fill (WLcor);
  ellipse (425,680,15,15);
  fill (255);
  textFont (helv, 13);
  text ("El\u00e9tron", 340, 685);
  text ("F\u00f3ton", 440, 685);
  
  
  
  textFont (helv, 11);
  text ("Cor\nCorrespondente\n\u00e0 Fun\u00e7\u00e3o Trabalho", XOffset[SimPG]+Hsize/2-Harea/2+30, YOffset[SimPG]+Vsize/2+Harea/2-69);
  
  
  text ("C\u00e2mara de V\u00e1cuo", 750, 55);
  text ("Emissor", 420, 90);
  text ("Bateria", 670, 500);
  text ("Circuito", 750, 470);
  text ("Coletor", 615, 240);
  
}

// ==============================================================

// STATUS BOX

public void statusBox()
{
  fill(10,20,30);
  noStroke();
  rect (5, 30+15+Controls.height, 280, height-100-Vsize);
  fill(20,20,70);
  rect (5, 30+15+Controls.height, 280, 20);
  textFont (helv, 14);
  fill(255);
  if (help.isSelected())  text ("Modo AJUDA", 10, 30+30+Controls.height);
  else text("Modo GR\u00c1FICO", 10, 30+30+Controls.height);
}

public void statusText (int index)
{
  pushStyle();
  fill (255);
  stroke(50,130,255);
  strokeWeight(1);
  textFont (helv, 14);
  if (help.isSelected())
  {
    pushMatrix();
    translate(0,-4);
    if (index>0) line (10, 103+Controls.height, 280, 103+Controls.height);
    switch (index)
    {
    case 0:
      text ("Passe o mouse sobre um item para obter\ninstru\u00e7\u00f5es. Passe o mouse sobre esta caixa\npara obter ajuda a respeito do gr\u00e1fico\nCorrente vs. Voltagem.\n\nItens com ajuda: todos os controladores,\nbot\u00f5es, emissor, coletor, bateria,\namper\u00edmetro, gr\u00e1fico, janela de visualiza\u00e7\u00e3o\ntridimensional. ", 10, 100+Controls.height);
      break;
    case 1:
      textFont (helv, 13);
      text ("SELETOR DA ENERGIA (ou FREQU\u00caNCIA) DA\nRADIA\u00c7\u00c3O EMITIDA PELAFONTE LUMINOSA\nControla a energia dos f\u00f3tons incidentes.\nObserve que se a Fun\u00e7\u00e3o Trabalho do\nmaterial do emissor for superior \u00e0 energia\ndos f\u00f3tons incidentes, nenhum el\u00e9tron ser\u00e1\nliberado da superf\u00edcie do Emissor.\nTECLADO                             mais = 7 | menos = 1\nCLIQUE ESQUERDO    define cursor\nCLIQUE DIREITO             volta a posi\u00e7\u00e3o inicial", 10, 100+Controls.height-14);
      break;
    case 2:
      text ("SELETOR DA MAGNITUDE DA\nFUN\u00c7\u00c3O TRABALHO DO EMISSOR\nControla o valor da Fun\u00e7\u00e3o de Trabalho,\nque representa a energia m\u00ednima que deve\nser fornecida a um el\u00e9tron para liber\u00e1-lo\nda superf\u00edcie de um dado material s\u00f3lido.\n\nTECLADO                            mais = 9 | menos = 3\nCLIQUE ESQUERDO    define cursor\nCLIQUE DIREITO             volta a posi\u00e7\u00e3o inicial", 10, 100+Controls.height-15);
      break;
    case 3:
      text ("INTENSIDADE LUMINOSA\nEste dimmer controla a intensidade\nda radia\u00e7\u00e3o emitida pela fonte luminosa,\ne, consequentemente, a densidade de\nf\u00f3tons do feixe irradiado.\n\nTECLADO                            menos = 4 | mais = 6\nCLIQUE ESQUERDO   define cursor\nCLIQUE DIREITO            50%", 10, 100+Controls.height);
      break;
    case 4:
      text ("INTENSIDADE DA FEM\nEste dimmer controla o sentido e intensidade\nda For\u00e7a Eletromotriz (FEM) gerada pela\nbateria. A barra colorida indicada na bateria\nrepresenta a intensidade e o lado positivo[+].\n\nTECLADO                          mais = 8 | menos = 2\nCLIQUE ESQUERDO define cursor\nCLIQUE DIREITO          zera FEM", 10, 100+Controls.height);
      break;
    case 5:
      text ("MODOS DE VISUALIZA\u00c7\u00c3O DA RADIA\u00c7\u00c3O\nEMITIDA PELA FONTE LUMINOSA\nUm clique no bot\u00e3o alterna entre os modos\ndiscreto e cont\u00ednuo da radia\u00e7\u00e3o emitida\npela fonte luminosa.\nO modo cont\u00ednuo ajuda na visualiza\u00e7\u00e3o dos\nel\u00e9trons emitidos.\n\nLIBERADO (default)         modo DISCRETO\nPRESSIONADO                 modo CONT\u00cdNUO\n\nCLIQUE     alterna modo Cont\u00ednuo/Discreto", 10, 100+Controls.height-15);
      break;
    case 6:
      text ("BATERIA\nEste indicador mostra a intensidade\ne sentido da fem gerada no circuito. A barra\ncolorida indica o p\u00f3lo positivo da bateria.", 10, 100+Controls.height);
      break;
    case 7:
      text ("EMISSOR\nEste \u00e9 o Emissor do experimento.\nQuando irradiado com f\u00f3tons de energia\nsuperior \u00e0 Fun\u00e7\u00e3o de Trabalho do\nmaterial de que \u00e9 constitu\u00eddo, emite\nel\u00e9trons a partir de sua superf\u00edcie. Dada\nsua origem f\u00edsica, esses el\u00e9trons s\u00e3o\nusualmente denominados Fotoel\u00e9trons.", 10, 100+Controls.height);
      break;
    case 8:
      text ("COLETOR\nEste \u00e9 o Coletor do experimento. Ele\ncoleta os el\u00e9trons liberados pelo emissor\ne completa o circuito. Com a ajuda de\num amper\u00edmetro, \u00e9 poss\u00edvel medir a\ncorrente gerada pelos fotoel\u00e9trons no\ncircuito.", 10, 100+Controls.height);
      break;
    case 9:
      text ("GR\u00c1FICO CORRENTE VS. VOLTAGEM\nPara os par\u00e2metros definidos pelo usu\u00e1rio,\no gr\u00e1fico exibe a curva que correlaciona a\ncorrente presente no circuito com a FEM\nimpressa pela bateria. Os eixos auxiliares\nse cruzam no ponto da curva que representa a\nsitua\u00e7\u00e3o atual. O ponto onde a curva\nintercepta o eixo das voltagens \u00e9 a\ndenominada \"VOLTAGEM DE CORTE\"  (Vo).", 10, 100+Controls.height);
      break;
    case 10:
      text ("AMPER\u00cdMETRO\nO Amper\u00edmetro ilustra a corrente que passa\npelo circuito sob as condi\u00e7\u00f5es f\u00edsicas\nselecionadas.O valor dessa corrente\ncorresponde \u00e0 do regime permanente da\nintera\u00e7\u00e3o f\u00f3ton-el\u00e9tron, que tem in\u00edcio quando\nos primeiros f\u00f3tons chegam ao emissor.", 10, 100+Controls.height);
      break;
    case 11:
      text ("VISUALIZA\u00c7\u00c3O TRIDIMENSIONAL\nEsta \u00e9 uma visualiza\u00e7\u00e3o art\u00edstica e\ntridimensional da intera\u00e7\u00e3o f\u00f3ton-el\u00e9tron que\nocorre no c\u00e1todo. As esferas brancas\nrepresentam os el\u00e9trons do emissor e as\nesferas menores coloridas, os f\u00f3tons\nincidentes.", 10, 100+Controls.height);
      break;
    }
    popMatrix();
  }
  popStyle();
}

float wlA, wlB, roam;
int photoact, direction, butSel ;
boolean click1, click2, runonce;

public int tutorial (int tut)
{
  float Ox, Oy;
  float l, fontsize;

  Ox=(width-wT)/2;
  Oy=(height-hT)/2;

  if (tutNext.isSelected())
  {
    runonce=false;
    if (tut<12) tut++;
    else 
    {
      tutorial.unSelect();
    }
    tutNext.unSelect();
  }
  if (tutPrev.isSelected())
  {
    runonce=false;
    if (tut>1) tut--;
    tutPrev.unSelect();
  }


  pushMatrix();                        //PUSH A
  translate (Ox, Oy);
  fill (150,200,255);
  stroke(255);
  strokeWeight(3);
  rect (0,0, wT, hT);
  fill (0); 

  fill(0);
  textFont(verdanab, 20);
  textAlign (CENTER);
  text ("TUTORIAL", wT/2, 40);
  textSize(14);
//  text ("(em revis\u00e3o)",wT/2+120, 38);

  textFont(helv, 18);
  text (tut+"/12", wT/2, hT-40);

  textAlign (LEFT);

  switch (tut)
  {
  case 1:
  case 2:

    if (tut==1)
      text ("Ol\u00e1. Este tutorial ir\u00e1 gui\u00e1-lo pelas principais caracter\u00edsticas da anima\u00e7\u00e3o relacionadas ao Efeito\n"+
        "Fotoel\u00e9trico. Primeiro vamos entender o fen\u00f4meno que governa esse efeito.\n\n"+
        "                                                                              O  EFEITO  FOTOEL\u00c9TRICO\n\n"+
        "O Efeito Fotoel\u00e9trico consiste na emiss\u00e3o de el\u00e9trons pela superf\u00edcie de um material, quando sobre  \n"+
        "ela incide radia\u00e7\u00e3o eletromagn\u00e9tica, como ilustrado na figura. Por simplicidade, e sem comprometer\n"+
        "a generalidade da explica\u00e7\u00e3o, consideraremos a radia\u00e7\u00e3o incidente monocrom\u00e1tica.\n"+
        "\nTodos os materiais s\u00f3lidos possuem uma \n"+
        "grandeza caracter\u00edstica denominada \n"+
        "FUN\u00c7\u00c3O TRABALHO, que representa a \n"+
        "energia m\u00ednima necess\u00e1ria para libertar \n"+
        "os el\u00e9trons da superf\u00edcie do  s\u00f3lido. \n"+
        "Sabemos tamb\u00e9m, que a energia de um \n"+
        "f\u00f3ton \u00e9 igual \u00e0 constante de Plank vezes a \n"+
        "frequ\u00eancia da radia\u00e7\u00e3o. Assim, a partir \n"+
        "da igualdade entre a fun\u00e7\u00e3o trabalho e a \n"+
        "energia do f\u00f3ton, podemos definir uma \n"+
        "grandeza caracter\u00edstica do processo, a \n"+
        "chamada FREQU\u00caNCIA DE CORTE."

        , 30,80);

    if (tut==2)
      text ("Quando a energia dos f\u00f3tons da radia\u00e7\u00e3o incidente \u00e9 maior que a fun\u00e7\u00e3o trabalho ou, equivalente-\n"+
        "mente, quando sua frequ\u00eancia \u00e9 maior do que a de corte, el\u00e9trons podem ser emitidos da superf\u00edcie\n"+
        "irradiada, sendo, nesse caso, chamados \"fotoel\u00e9trons\". A densidade dos fotoel\u00e9trons emitidos au -\n"+
        "menta com o aumento da intensidade da radia\u00e7\u00e3o incidente. Por outro lado, quando a energia dos  \n"+
        "f\u00f3tons \u00e9 menor que  a fun\u00e7\u00e3o trabalho, independentemente da intensidade da radia\u00e7\u00e3o incidente,  \n"+
        "el\u00e9trons n\u00e3o ser\u00e3o emitidos da superf\u00edcie irradiada (vide figura).\n"+ 
        "\nPela explica\u00e7\u00e3o do Efeito Fotoel\u00e9trico, descoberto em 1839 por A. E. Becquerel e confirmado \n"+
        "em 1887 por Heinrich Hertz, Albert Einstein recebeu o Pr\u00eamio Nobel de F\u00edsica de 1921.\n"+

        "\nEm nossa anima\u00e7\u00e3o, consideramos apenas o\n"+
        "caso de emissores met\u00e1licos com radia\u00e7\u00e3o\n"+
        "eletromagn\u00e9tica monocrom\u00e1tica limitada \u00e0\n"+
        "faixa de frequ\u00eancias do espectro vis\u00edvel,\n"+
        "isto \u00e9, do vermelho ao violeta."

        , 30,80);


    //image (tut11, 40, 300);
    image (tut12, 400, 285);
    textFont (helv, 12);
    textAlign(CENTER);
    text ("Wikimedia Commons - Photoelectric effect", 600,545);
    if (tut==2)
    {

      fill(150,200,255);
      noStroke();
      rect (610,280,150,174);
      fill(255,0,0);
    }
    else
    {
      fill(255,0,0);
      text ("El\u00e9trons", 710, 300);
    }
    text ("Radia\u00e7\u00e3o Eletromagn\u00e9tica\n(f\u00f3tons)", 470, 280);
    text ("Material S\u00f3lido", 710,520);
    break;

  case 3:

    text ("Agora, vamos descrever a \u00e1rea de da tela onde animamos o experimento que ilustra o Efeito Foto-\n"+
      "el\u00e9trico. Ela \u00e9 composta de uma C\u00e2mara de V\u00e1cuo (1) dentro da qual temos: um Emissor (2), s\u00f3lido de \n"+
      "metal em formato c\u00f4ncavo que recebe radia\u00e7\u00e3o proveniente da fonte luminosa localizada na regiao (5), \n"+
      "de um Coletor (8), eletrodo puntiforme que coleta el\u00e9trons liberados da superf\u00edcie do emissor. Do lado\n"+
      "externo, temos um Amper\u00edmetro (6), que mede a corrente que passa pelo Circuito (7) e de uma Bateria,\n"+
      "(4) capaz de nele imprimir uma for\u00e7a eletro-motriz. H\u00e1 ainda um indicador (3) que representa qual cor \n"+
      "do espectro vis\u00edvel \u00e9 constitu\u00edda de f\u00f3tons que tem energia igual \u00e0 da Fun\u00e7\u00e3o Trabalho do Emissor.\n"+
      "O circuito el\u00e9trico por onde flui a corrente \u00e9 destacado em amarelo na figura."
      , 30,80);


    if (!runonce)
    {

      translate(0,40);

      image(Simulation, 180,210, 455, 325);
      pushStyle();

      fill (200,250,240,150);
      noStroke();
      rect(520,250,20,200);

      fill (200,250,240);
      stroke (30,255,170,150);
      strokeWeight(2);
      int radi=35;

      line (100,270,245,280);
      line (100,340,270,340);
      line (100,410,270,445);
      line (100,490,298,505);
      line (720,270,530,270);
      line (720,340,620,305);
      line (720,410,614,380);
      line (720,490,405,355);
      ellipse (100,270,radi, radi);
      ellipse (100,340,radi, radi);
      ellipse (100,410,radi, radi);
      ellipse (100,490,radi, radi);
      ellipse (720,270,radi, radi);
      ellipse (720,340,radi, radi);
      ellipse (720,410,radi, radi);
      ellipse (720,490,radi, radi);

      fill(0);
      textAlign(CENTER);
      text ("1", 100,275);
      text ("2", 100,345);
      text ("3", 100,415);
      text ("4", 100,495);
      text ("5", 720,275);
      text ("6", 720,345);
      text ("7", 720,415);
      text ("8", 720,495);

      noFill();
      stroke(255,255,0,100);
      strokeWeight(4);
      rect (195,355,419,158);




      popStyle();
    }




    break;

  case 4:

    text ("Relembrando, para que se observe a ocorr\u00eancia do Efeito Fotoel\u00e9trico, a frequ\u00eancia dos f\u00f3tons da\n"+
      "da radia\u00e7\u00e3o incidente sobre o emissor deve ser maior que a frequ\u00eancia de corte do emissor ou,\n"+
      "equivalentemente, a energia dos f\u00f3tons incidentes deve ser maior que a fun\u00e7\u00e3o trabalho do emissor.\n"+
      "Por outro lado, quando os fotons possuem frequ\u00eancia menor que a de corte (ou seja, energia menor\n"+
      "que a fun\u00e7\u00e3o trabalho), n\u00e3o h\u00e1 libera\u00e7\u00e3o de el\u00e9trons a partir da superf\u00edcie do emissor.\n"+
      "Nesta anima\u00e7\u00e3o, a Fun\u00e7\u00e3o Trabalho do emissor, bem como a energia dos f\u00f3tons incidentes s\u00e3o \n"+
      "representados por uma cor, que pode variar do vermelho ao violeta. Essas energias podem ser\n"+
      "ajustadas pelo usu\u00e1rio por meio dos controles \"Seletor de Cor da Fonte Luminosa\" e \"Seletor\n"+
      "da Fun\u00e7\u00e3o Trabalho do Emissor\", que possuem o aspecto da barra colorida mostrada abaixo.\n"+
      "Cada cor da barra corresponde a uma energia espec\u00edfica\n"+
      "ou, equivalentemente, a uma frequ\u00eancia espec\u00edfica.\n"+
      "Para alterar a energia, basta clicar o mouse sobre\n"+
      "a barra na cor desejada\n\n"+
      "Sabe-se que, de acordo com a equa\u00e7\u00e3o de Plank, a energia \n"+
      "do f\u00f3ton (E) e a frequ\u00eancia da radia\u00e7\u00e3o (f) s\u00e3o linearmente\n"+
      "proporcinais:\n"+
      "                                                       E = h f  ,\n"+
      "onde h=6,626068*10     m\u00b2kg/s \u00e9 a constante de Plank. \n"+
      "Do comportamento ondulat\u00f3rio da radia\u00e7\u00e3o, temos que:\n"+
      "                                                        c = \u03bb f  ,\n"+
      "onde c \u00e9 a velocidade da luz e \u03bb seu comprimento de onda.\n"
      , 30,80);
    noStroke();
    fill (255,150);
    rect (520, 280, 270, 270);
    fill(0);
    stroke(0);
    tutorialA.update();
    tutorialA.show();
    wlA= round(map(tutorialA.getVal(), 0, tutorialA.GetDim('h'), 380, 750));
    text ( "Comp. Onda = " + wlA + " nm", 650,380);
    text ( "Frequ\u00eancia    = " + nf(300000/wlA, 3, 1) + " THz", 650,450);
    text ( "Energia            = " + nf(300000/wlA*0.004135667f, 1, 3) + " eV", 650,520);

    textSize (12);
    text ("-34", 255,500);


    //click1=false;
    //click2=false;
    //unonce=false;
    direction=3;

    break;

  case 7:
    click1=true;
    if (!runonce)
    { 
      click1=click2=false;
      tutorialA.setVal(45);
      tutorialB.setVal(10);
      runonce=true;
    }
  case 5:
    if (!runonce)
    { 
      click1=click2=false;
      runonce=true;
    }
  case 6:


    if (tut==5) {
      text ("Vamos analisar quais s\u00e3o os resultados da manipula\u00e7\u00e3o dos controles seletores de energia na\n"+
        "anima\u00e7\u00e3o. O controle da direita foi associado \u00e0 \"FUN\u00c7\u00c3O TRABALHO do EMISSOR\". Isso significa\n"+
        "que ele define a energia m\u00ednima para libera\u00e7\u00e3o de el\u00e9trons a partir da superf\u00edcie do emissor. O  \n"+
        "controle da esquerda, por sua vez, representa a energia dos f\u00f3tons da radia\u00e7\u00e3o incidente no emissor.\n"       
        , 30,80);
      text ("Altere a energia dos f\u00f3tons incidentes (clicando na barra colorida da esquerda) e a fun\u00e7\u00e3o trabalho\n"+
        "do emissor (clicando na barra colorida da direita) e explore sua correla\u00e7\u00e3o com a ocorr\u00eancia do\n"+
        "Efeito Fotoel\u00e9trico. Isso pode ser verificado observando-se a cor do indicador circular abaixo. \n"+
        "Quando o efeito fotoel\u00e9trico ocorre, o indicador possui cor verde e quando o efeito nao ocorre, \n"+
        "cor vermelha."
        , 30,180);
    }

    if (tut==6)
      text ("Al\u00e9m disso, no Efeito Fotoel\u00e9trico, quanto maior for a energia dos f\u00f3tons da radia\u00e7\u00e3o incidente no \n"+
        "emissor, em rela\u00e7\u00e3o \u00e0 fun\u00e7\u00e3o trabalho do emissor, maior ser\u00e1 a energia cin\u00e9tica m\u00e1xima dos el\u00e9trons \n"+
        "liberados. Isso est\u00e1 ilustrado, na figura abaixo, pela barra amarela. Como \u00e9 poss\u00edvel estimar mate- \n"+
        "maticamente  essa energia cin\u00e9tica? Ser\u00e1 discutido adiante.\n\n"+
        "Altere a energia dos f\u00f3tons incidentes e a fun\u00e7\u00e3o trabalho do emissor e explore sua correla\u00e7\u00e3o com\n"+
        "a energia cin\u00e9tica m\u00e1xima dos el\u00e9trons liberados pelo emissor , representada pelo comprimento da\n"+
        "barra amarela"

        , 30,80);
    if (tut==7)
    {
      textSize(14);
    text ("Consideraremos agora a influ\u00eancia da intensidade da radia\u00e7\u00e3o emitida pela fonte luminosa no Efeito Fotoel\u00e9trico, que \u00e9 controlada\n"+
      " na anima\u00e7\u00e3o pelo dimmer \"Intensidade Luminosa\".\n"+
      "A frequ\u00eancia da radia\u00e7\u00e3o luminosa determina a energia dos f\u00f3tons incidentes no emissor, enquanto a intensidade determina o fluxo\n"+
      "dos f\u00f3tons incidentes. Quando a energia dos f\u00f3tons \u00e9 suficiente para originar o Efeito Fotoel\u00e9trico, o aumento da  intensidade \n"+
      "da radia\u00e7\u00e3o leva a um aumento da corrente de fotoel\u00e9trons gerada no circuito. No entanto, quando a energia dos f\u00f3tons \u00e9 inferior\n"+
      "\u00e0 necess\u00e1ria para gerar o Efeito Fotoel\u00e9trico, a corrente de fotoel\u00e9trons \u00e9 nula independentemente da intensidade da radia\u00e7\u00e3o\n"+
      "incidente no emissor. Na figura abaixo, o comprimento barra azul est\u00e1 correlacionado com a grandeza da corrente de fotoel\u00e9trons \n"+
      "no circuito. Usando os seletores de energia, escolha uma condi\u00e7\u00e3o em que o Efeito Fotoel\u00e9trico ocorre (indicador verde e barra\n"+
      "                                                                                                                      amarela aparecem) e veja a influ\u00eancia da intensidade luminosa utilizando \n"+
      "                                                                                                                      o dimmer Intensidade Luminosa\". Repita o procedimento, escolhendo uma\n"+
      "                                                                                                                      condi\u00e7\u00e3o em que o Efeito Fotoel\u00e9trico n\u00e3o ocorre (indicador vermelho)."
      , 30,80);
    }

    if(!click1 && tut!=7)        // sliding movement case 3 and 4 untill user clicks slider
    {
      if (!tutorialB.increment(direction)) direction*=-1;
      if (tutorialB.isLocked()) click1=true;
    }
    if(!click2 && tut==7)       // sliding movement case 5 untill user clicks slider
    {
      if (!tutorialC.increment(direction)) direction*=-1;
      if (tutorialC.isLocked()) click2=true;
    }


    noStroke();
    fill (255,150);
    rect (520, 280, 275, 270);
    rect (35, 280, 275, 270);
    fill(0);
    stroke(0);

    tutorialA.update();
    tutorialA.show();
    wlA= round(map(tutorialA.getVal(), 0, tutorialA.GetDim('h'), 380, 750));
    text ( "      Seletor da Fun\u00e7\u00e3o Trabalho do\n                         EMISSOR ( \u03a6 )", 580,340);
    text ( "Comp. Onda = " + wlA + " nm", 650,420);
    text ( "Frequ\u00eancia    = " + nf(300000/wlA, 3, 1) + " THz", 650,480);
    text ( "Energia            = " + nf(300000/wlA*0.004135667f, 1, 3) + " eV", 650,540);

    tutorialB.update();
    tutorialB.show();
    wlB= round(map(tutorialB.getVal(), 0, tutorialB.GetDim('h'), 380, 750));
    text ( "Seletor de Cor da fonte luminosa", 110,340);
    text ( "Comp. Onda = " + wlB + " nm", 120,420);
    text ( "Frequ\u00eancia    = " + nf(300000/wlB, 3, 1) + " THz", 120,480);
    text ( "Energia            = " + nf(300000/wlB*0.004135667f, 1, 3) + " eV", 120,540);


    if (wlA>wlB) photoact=1;       // not emitting
    else photoact=0;               // emitting
    translate (Ox, Oy);
    translate (wT/2, 480);
    stroke(255);


    textAlign(CENTER);

    if(tut>5)
    { 
      stroke(255,230,0);
      strokeWeight(20);
      if (wlA>wlB)
      {

        line (0,-20,0,map(wlB-wlA, 0, 750-380, 0, 100)-20);          // kinetic energy indicator
      }
      fill(255,255,0);
      text ("Enegia\nCin\u00e9tica", 0, -155);
      fill(0);
    }
    if(tut>6)
    { 
      // pushStyle();
      textSize(13);
      text ("Intensidade\nLuminosa", -110, -240);
      stroke(0,0,255);
      strokeWeight(20);

      if (wlA>wlB)
      {
        //println (map(tutorialC.getVal(), 0, 100, 0, 20));
        line (10, 0, 10+map(wlB, 380, 750, 2.8f,1)*map(tutorialC.getVal(), 0, 100, 0, 30), 0);          // current indicator
      }
      //popStyle();
      fill(0);
    }


    if (tut<7) {
      text ("Efeito\nFotoel\u00e9trico", 0, 50); 
      if (photoact==1) text ("ocorre", 0, 93);
      if (photoact==0) text ("n\u00e3o ocorre", 0, 93);
    }
    else { 
      fill(0,0,255);       
      text ("Corrente", 0, 50);
    }

    fill((1-photoact)*255, photoact*255, 0);
    strokeWeight(2);
    ellipse (0,0,40,40);

    if(tut>6)
    { 
      textSize(14);
      fill(0);
      text("0",-322,-247);
      text("100%",-170,-247);
      tutorialC.update();
      tutorialC.show();
    }

    textAlign(LEFT);
    break;

  case 8:
    pushStyle();
    textFont(helv, 16);
    text ("Para explicar o Efeito Fotoel\u00e9trico, isto \u00e9, a exist\u00eancia de uma frequ\u00eancia m\u00ednima (frequ\u00eancia de corte) da\n"+
      "radia\u00e7\u00e3o incidente no emissor, abaixo da qual n\u00e3o h\u00e1 gera\u00e7\u00e3o de fotoel\u00e9trons, Einstein desenvolveu uma teoria\n"+
      "de que o feixe de luz pode ser pensado como sendo constitu\u00eddo por pacotes de energia, denominados f\u00f3tons, \n"+
      " ou quanta. A energia de um f\u00f3ton seria proporcional a sua frequ\u00eancia por uma constante 'h', a  constante de \n"+
      "Planck, de acordo com a rela\u00e7\u00e3o E = hf, j\u00e1 apresentada (p\u00e1g. 4). O processo de transfer\u00eancia de energia do f\u00f3ton\n"+
      "ao el\u00e9tron do emissor \u00e9 um processo bin\u00e1rio, ou seja, ou \u00e9 transferida toda a energia do f\u00f3ton para o el\u00e9tron, ou\n"+
      "nenhuma energia \u00e9 transferida. Al\u00e9m disso, um el\u00e9tron n\u00e3o pode absorver simultaneamente a energia de mais de\n"+
      "um f\u00f3ton. Abaixo \u00e9 apresentada uma concep\u00e7\u00e3o art\u00edstica tridimensional desse fen\u00f4meno. A esfera branca em\n"+
      "trajet\u00f3ria orbital representa o el\u00e9tron exposto a f\u00f3tons incidentes, com fluxo fixo, representadas pelas esferas\n"+
      "coloridas. Suponha que a fun\u00e7\u00e3o trabalho do emissor seja 2,3eV, que \u00e9 a energia associada \u00e0 luz verde.\n"+
      "Clique sobre os controles vermelho e azul abaixo, e veja o que acontece com as intera\u00e7\u00f5es f\u00f3ton-el\u00e9tron:\n"        
      , 30,80);
    popStyle();
    text ("ENERGIA DOS F\u00d3TONS", 300,320);
    fill(255,0,0);
    text ("<=  menor que", 260,338);
    fill(0,0,255);
    text ("maior que  =>", 430,338);
    fill(0);
    text ("/", 400,338);

    fill (20,160,0);
    text ("FUN\u00c7\u00c3O TRABALHO DO EMISSOR", 250,360);

    if (!runonce)
    {
      //println("RUNEI");
      catWL=530;
      blackout();  // limpa PGraphics Micro
      runonce=true;
    }

    if (butSel==0)
      fotIntensity=100.f/0;
    else fotIntensity=1;
    if (butSel==1)
      sourceWL=650;
    if (butSel==2)
      sourceWL=450;

    // MICRO control instance

    Micro.background(0);
    eelectron.update();
    eelectron.display();
    for (int i=0; i<ffotonN; i++)
    {
      ffoton[i].setWL(sourceWL);
      ffoton[i].update();
      ffoton[i].display();
    }

    if (frameCount%PApplet.parseInt(fotIntensity*4)==0 )
    {
      ffoton[ffotonIndex].trigger();
      ffotonIndex ++;
    }
    if (ffotonIndex >= ffotonN) ffotonIndex=0;

    image (Micro, 85, 370);
    butSel = tutButtons(runonce);



    break;

  case 9:
    pushStyle();
    textFont(helv, 16);
    text ("J\u00e1 vimos que existe uma energia m\u00ednima que o f\u00f3ton da radia\u00e7\u00e3o incidente deve apresentar para haver libera\u00e7\u00e3o\n"+
      "\u00e7\u00e3o de el\u00e9trons na superf\u00edcie do emissor, e que ela \u00e9 definida pela frequ\u00eancia da radia\u00e7\u00e3o. Se o f\u00f3ton possuir\n"+
      "energia maior do que a correspondente \u00e0 frequ\u00eancia de corte, ap\u00f3s a intera\u00e7\u00e3o f\u00f3ton-el\u00e9tron, o el\u00e9tron ter\u00e1 energia\n"+
      "suficiente para se libertar da superf\u00edcie do emissor, al\u00e9m de energia adicional na forma de energia cin\u00e9tica. Como\n"+
      "conhecemos a energia dos f\u00f3tons incidentes h.f, se aplicarmos uma diferen\u00e7a de voltagem desaceleradora entre\n"+
      "o emissor e o coletor de magnitude Vo tal que a velocidade dos el\u00e9trons se anule ao chegar ao coletor, podemos\n"+
      "estimar a energia cin\u00e9tica inicial Kmax dos el\u00e9trons, pois \n"+
      "                                                                                                                                              Kmax  = e.Vo = h.f - \u03a6 \n\n"+
      "                                                                                                      Note que a diferen\u00e7a de voltagem Vo (Potencial de corte)\n"+
      "                                                                                                      independe da radia\u00e7\u00e3o incidente."
      , 30,70);

    /*text ("onde Vo \u00e9 o POTENCIAL DE CORTE, a partir do qual \n"+
     "a corrente cessa, pois os el\u00e9trons est\u00e3o sendo acelerados \n"+
     "de volta para o Emissor e n\u00e3o conseguem chegar ao Coletor."
     , 320,250);*/

    /*text ("mas como\n"+
     "Kmax = mv\u00b2/2 = h.f - \u03a6\n\n"+
     "a equa\u00e7\u00e3o fica\n\n"+
     "              e.Vo = h.f - \u03a6 "
     , 30,340);  */

    //noFill();
    //stroke(0);
    //rect (46,414,150,30);

    text ("Varie os par\u00e2metros \n"+
      "exibidos e observe seus\n"+ 
      "respectivos efeitos sobre\n"+
      "o valor do Potencial de \n"+
      "Corte (Vo)"
      , 30,400);     

    popStyle();

    if (!runonce) tutOverride=true;

    WLcor = convert(round(map(tutorialB.getVal(), 0, wlSource.GetDim('h'), 350, 780)), fotonAlpha);

    tutorialB.update();
    tutorialB.show();
    tutorialC.update();
    tutorialC.show();
    textSize(14);
    fill(0);
    text("0",147,268);
    text("100%",287,268);

    pushMatrix();
    text ("Intensidade\n   Luminosa", 184,320);
    translate (330, 480);
    rotate(-HALF_PI);
    text ("Sel. de Cor da\n Fonte Luminosa", -20, -20);
    popMatrix();    // trocar esses dois por um translate incremental

    noStroke();
    fill (90,170,205);
    rect (410,350,330,220);
    fill(0);

    pushMatrix();
    translate (400,-280);
    scale(1.2f);
    drawGraphic(fem.getVal(), tutorialB.getVal(), tutorialC.getVal());

    popMatrix();

    break;

  case 10:
    text ("Finalmente, o termina-se a montagem do circuito com o Amper\u00edmetro.\n"+
      "Este instrumento nos d\u00e1 a informa\u00e7\u00e3o que fecha o experimento, a corrente \n"+
      "que passa pelo circuito. Esse \u00e9 o principal dado de sa\u00edda do experimento, \n"+
      "e relaciona-se \u00e0 FEM aplicada no circuito. Ele permite a plotagem do gr\u00e1fico \n"+
      "\"Corrente vs. Voltagem\", a partir  do qual identifica-se a Voltagem de Corte. \n\n"+
      "O funcionamento deste aparelho est\u00e1 correlacionado com quase \n"+
      "todas as outras vari\u00e1veis da anima\u00e7\u00e3o. Por esse motivo, deixamos \u00ea\n"+
      "para que vocteste-o fora deste tutorial, que est\u00e1 quase no fim.\n\n\n"+
      "Por \u00faltimo, na p\u00e1gina seguinte, apresentaremos as principais das \nutilidades pr\u00e1ticas do Efeito Fotoel\u00e9trico."
      , 30,80);

    strokeWeight(0);
    translate(80,-38);
    buildAmp(g);

    break;

  case 11:

    text ("UTILIDADES", 358,70);

    text ("\n"+
      "1. FOTOMULTIPLICADORES: Tubos de v\u00e1cuo, extremamente sens\u00edveis \u00e0 radia\u00e7\u00e3o eletro-\n"+
      "         magn\u00e9tica, tanto na regi\u00e3o  vis\u00edvel do espectro, quanto nas suas vizinhan\u00e7as. S\u00e3o capazes de \n"+
      "         multiplicar intensidades de radia\u00e7\u00e3o de at\u00e9 100 milh\u00f5es de vezes, por possuirem um alto ganho \n"+
      "         e pouco ruido. S\u00e3o de grande utilidade na \u00e1rea m\u00e9dica e nuclear.\n\n"+
      "2. SENSORES DE IMAGEM: Os sensores de imagem das primeiras c\u00e2meras filmadoras eletr\u00f4nicas \n"+
      "         usavam fotomultiplicadores.\n\n"+
      "3. ESPETROSCOPIA FOTOELETR\u00d4NICA : Em um ambiente de alto-v\u00e1cuo, uma amostra \u00e9 bom-\n"+
      "         bardeada por f\u00f3tons de raios X de energia conhecida. Como a energia dos fotoel\u00e9trons\n"+
      "         emitidos \u00e9 igual \u00e0 energia dos f\u00f3tons incidente menos a Fun\u00e7\u00e3o Trabalho do material da amostra,\n"+
      "         \u00e9 possivel determinar a Fun\u00e7\u00e3o Trabalho, e assim, a identidade qu\u00edmica do material.\n\n"+
      "4. ELETROSC\u00d3PIO DE FOLHAS: Capaz de indicar a presen\u00e7a de carga el\u00e9trica, funciona pela \n"+
      "         repuls\u00e3odas finas folhas carregadas em seu interior. Quando o eletrosc\u00f3pio est\u00e1 carregado\n"+
      "         negativamente e \u00e9 exposto \u00e0 luz de frequ\u00eancia superior \u00e0 frequ\u00eancia de corte do material das\n"+
      "         folhas, os el\u00e9trons s\u00e3o liberados das suas superf\u00edcies e o aparelho \u00e9 descarregado, \n"+
      "         fazendo com que as folhas met\u00e1licas caiam.\n\n"+
      "4. VIS\u00c3O NOTURNA: A imagem de equipamentos de vis\u00e3o noturna \u00e9 gerada a partir de fotoel\u00e9trons \n"+
      "         emitidos por um filme semicondutor, que colidem com uma tela revestida de f\u00f3sforo, onde\n"+
      "         a imagem \u00e9 gerada.\n"

      , 30,80);


    translate(80,-38);
    break;

  case 12:
    textFont (helv, 20);
    text ("Assim termina o Tutorial da Anima\u00e7\u00e3o \"Efeito Fotoel\u00e9trico\".\n"+
      "Obrigado por acompanhar esta explica\u00e7\u00e3o e boa anima\u00e7\u00e3o!", 150,150);

    break;
  }
  popMatrix();

  return tut;
}

public int tutButtons (boolean runonce)
{
  float x1, y1, x2, y2, rad;
  int A, B;

  if (!runonce) selected=0;

  pushMatrix();
  pushStyle();
  resetMatrix();
  x1=250;
  x2=670;
  y1=y2=365;
  rad=40;

  if (mousePressed && sqrt((mouseX-x1)*(mouseX-x1)+(mouseY-y1)*(mouseY-y1))<=rad/2)
    selected=1;
  if (mousePressed && sqrt((mouseX-x2)*(mouseX-x2)+(mouseY-y2)*(mouseY-y2))<=rad/2)
    selected=2;

  A=B=color(100);
  if (selected==1) A=color (255,230,0);
  if (selected==2) B=color (255,230,0);

  stroke(A);
  fill(255,0,0);
  ellipse (x1, y1, rad, rad);
  stroke(B);
  fill(0,0,255);
  ellipse (x2, y2, rad, rad);

  popStyle();
  popMatrix();                  //POP A
  return selected;
}

PImage plogo;

public void showCredits ()
{
  int h, w;
  float l, fontsize;
  h=640;
  w=820;
  fontsize = 16;
  
  pushMatrix();
  
  translate ((width-w)/2, (height-h)/2);
  fill (255,225);
  rect (0,0, w, h);
  
  l=0.1f*h;
  fill(0);
  textAlign(CENTER);
  textFont (verdanab, 20);
  text ("CR\u00c9DITOS",w/2, 30);
  textAlign(LEFT);
  
  textFont (helv, fontsize);
  text ("Desenvolvimento:",20, l);
  text ("Giovanni Garaldi Biasi (aluno do 2\u00ba ano do Curso de Engenharia Mec\u00e2nica,\nEscola Polit\u00e9cnica da Universidade de S\u00e3o Paulo - SP, Brasil)", 150, l);
  l += fontsize*3;
  text ("Orienta\u00e7\u00e3o:",20, l);
  text ("Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metal\u00fargica e de Materiais,\nEscola Polit\u00e9cnica da Universidade de S\u00e3o Paulo - SP, Brasil)", 150, l);
  l += fontsize*3;
  text ("Texto:",20, l);
  text ("Giovanni Garaldi Biasi \nIvette F. C. Oppenheim", 150, l);
  text ("Ultima Modifica\u00e7\u00e3o: 20/02/2013", 420, l);
  
  l += fontsize*3;
  text ("Colabora\u00e7\u00e3o:",20, l);
  text ("Rafael Nahat (UI Objects)", 150, l);
  text ("Plataforma:", 420, l);
  text ("Processing v.1.2.1", 510, l);
  image(plogo, 650, l-30, 50,50);
  
  
  
  fontsize=15;
  textFont (verdanab, fontsize);
  l += fontsize*3;
  text ("Sobre a Anima\u00e7\u00e3o:", 20, l);
  textFont (helv, fontsize);
  l += fontsize*1.2f;
  text ("A simula\u00e7\u00e3o \"Efeito Fotoel\u00e9trico\" foi desenvolvida no contexto do projeto 'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias\n" +
        "de Ci\u00eancia e Engenharia dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o\n"+
        "da Universidade de S\u00e3o Paulo, ao qual expressamos agradecimento pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica.\n" +
        "(Programa 2882 -2011)"
        , 20, l);
  
  l += fontsize*6;
  textFont (verdanab, fontsize);
  fill(1,43,77);
  text ("Sobre o Processing:", 20, l);
  //fill(0);
  textFont (helv, fontsize);
  l += fontsize*1.2f;
  text ("Processing \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desenvolvimento opensource, multiplataforma, concebido\n" +
        "para artes eletr\u00f4nicas e comunidades de desenho visual baseado em Java, que conta com o compartilhamento\n"+
        "de c\u00f3digos e bibliotecas entre usu\u00e1rios em uma comunidade online. Foi iniciado em 2001 por Casey Reas e Ben Fry,\n" +
        "pesquisadores do MIT (Intituto de Tecnologia de Massachussets), e diponibilizado gratuitamente como software livre\n" +
        "no site 'processing.org', onde \u00e9 poss\u00edvel fazer download e encontrar diversas refer\u00eancias para seu uso."
        , 20, l);
  
  fontsize=15;
  fill (0);
  textFont (helv, fontsize);      
  l += fontsize*7;
  text ("Refer\u00eancias:", 20, l);
  text ("YOUNG, Hugh & FREEDMAN, Roger. Fisica 4. 12\u00aa ed. S\u00e3o Paulo: Addison Wesley, 2009", 140, l);
  l += fontsize*2;
  text ("Photoelectric Effect. Interactive Simulations. University of Colorado at Boulder. v.1.09\n" +
        "dispon\u00edvel em < http://phet.colorado.edu/en/simulation/photoelectric > (Acesso em 13/09/2011)", 140, l);
  l += fontsize*3;
  text ("FOWLER, Michael. The Photoelectric Effect. University of Virginia. dispon\u00edvel em \n" +
        "< http://galileo.phys.virginia.edu/classes/252/photoelectric_effect.html > (Acesso em 13/09/2011)", 140, l);
  l += fontsize*3;
  text ("BRUTON, Dan. Approximate RGB values for Visible Wavelengths. (aproxima\u00e7\u00e3o linear do algoritmo)\n" +
        "dispon\u00edvel em < http://www.physics.sfasu.edu/astro/color/spectra.html > (Acesso em 13/09/2011)", 140, l);
        
        
  popMatrix();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "P83_r6_compr" });
  }
}
