PImage light, standby;
PFont verdanab, helv, arialb;

WLslider wlSource, wlCat, tutorialA, tutorialB;
Particle[] foton, electron;
GUIslider intensity, fem, tutorialC;
Button sourceMode, credits, help, tutorial, tutNext, tutPrev;
FEMindicator indicator;
Solid eelectron, eSample, fSample;
Solid[] ffoton;


PGraphics Controls, Simulation;
PGraphics Micro;

int MainMode;
int sourceWL, catWL, globalVelocity, globalUniverse;
int ControlsPG, SimPG, MicroPG;
int counter, statusIndex;
boolean fotonModeContinuous, newElectronTriggered, helpMode, creditsMode, tutWasSelected, tutOverride;
color WLcor, ControlsBG, SimBG, srcColor, gBG;

float radius, femDim;                                 // scenario float
int Ox, Oy, Hsize, Vsize, Harea, Varea;               // scenario int
float fotRad, randHeight, fotIntensity, NFtriggered;  // foton float
int fotonUniverse, fotonAlpha, FLastTrig;             // foton int
float electronRad, NET;                               // electron float
int electronUniverse, electronAlpha, ELastTrig;       // electron int
float catRad, ang, temp;                              // cathode float
int ffotonN, eelectronRad, ffotonIndex, ffotonRad;    // 3D int
float x, y, w, hmax, t0, tmax, DD_h, DD_v, DD_w;      // drop down alert float
int dropdownTrigger;                                  // drop down alert int
float hT, wT ;                                      // tutorial float
int tutorialMode, selected;                         // tutorial int
PImage tut11, tut12;


float newElectronAng;              // position for the next electron to be triggered
float aceleration;

float[] eePos=new float[3];         // global variable for electron position on 3-dimentional view
float eeRad;

float lastaction, maxtime;
boolean insuspension;


int[] XOffset=new int[3], YOffset=new int[3];

void setup ()
{
  frameRate(25);
  smooth();
  size (945,710);
  
  //GLOBAL VARS
  MainMode=1;            // set starting to Tutorial (3) or Simulation (1);
  globalVelocity = 5;
  globalUniverse = 500;
  newElectronTriggered = false;
  dropdownTrigger = 0;
  verdanab = loadFont ("Verdana-Bold-20.vlw");
  helv = loadFont ("SansSerif.plain-20.vlw");
  arialb = loadFont ("Arial-BoldMT-20.vlw");
  
  helpMode=false;
  creditsMode=false;

  //SCENARIO
  Ox=20;  
  Oy=20;
  Hsize = 600; 
  Vsize = 420;
  Harea = 450; 
  Varea = 380; 
  radius= 20 ; 
  femDim= 50 ;
  catRad= 380; 
  ang   = 0.9*PI/3;

  //PGRAPHICS SETUP
  ControlsPG=0;
  SimPG=1;
  MicroPG=2;
  Controls   = createGraphics (280, 470, P2D);
  Simulation = createGraphics (Hsize+50, Vsize+50, P2D);
  Micro      = createGraphics (Hsize+50, height-100-Vsize, P3D);
  ControlsBG= color(10);
  SimBG= color(10);
  gBG= color (20,80,180);

  XOffset[ControlsPG] = 5;
  YOffset[ControlsPG] = 40;
  XOffset[SimPG] = 290;
  YOffset[SimPG] = 40;
  XOffset[MicroPG] = 290;
  YOffset[MicroPG] = Vsize+95;

  // TUTORIAL
  tutorialMode=1;
  hT=640;
  wT=820;
  tut12 = loadImage ("tut_phe2.png");
  tutorialA = new WLslider (g, 600, 360, 10, 200, 'e');
  tutorialB = new WLslider (g, 340, 360, 10, 200, 'd');
  tutorialC = new GUIslider (g, wT/2-260, 280, 150, 30, 0, 100, 75, 'b');        // 'b' for black background
  selected=0;
  tutWasSelected=false;
  tutOverride=false;
  
  //Continuous LIGHT
  light = loadImage ("light.png");  

  //FOTON
  fotonModeContinuous = true;
  fotonUniverse = globalUniverse;
  fotonAlpha = 180;
  fotRad = 7;    // foton Radius
  foton = new Particle[fotonUniverse];
  for (int i=0; i<foton.length; i++)
  {
    foton[i] = new Particle (Simulation, fotRad, globalVelocity, i, 'f');
    foton[i].reset();
  }

  //ELECTRON  
  electronUniverse = globalUniverse;
  electronAlpha = 180;
  electronRad = 5;
  electron = new Particle[electronUniverse];
  for (int i=0; i<electron.length; i++)
  {
    electron[i] = new Particle (Simulation, electronRad, globalVelocity, i, 'e');
  }

  //SLIDERS
  wlSource  = new WLslider (Controls, 50, 80, 10, 200, 'e');
  wlCat     = new WLslider (Controls, 220, 80, 10, 200, 'd');
  intensity = new GUIslider (Controls, 30, 330, 150, 30,    0, 100,  0, 's');        // 's' for solid background
  fem       = new GUIslider (Controls, 30, 380, 150, 30, -100, 100, 75, 'g');        // 'g' for gradient background

  //BUTTONs
  sourceMode = new Button (Controls, XOffset[ControlsPG], YOffset[ControlsPG], 140, 445, 200, 30, "  Fótons: Modo Discreto", "  Fótons: Modo Contínuo", color (50,50,200));
  help       = new Button (g, 0, 0, 90, 20, 140, 30, "AJUDA Desativada", "AJUDA Ativada", color (210,240,0));
  credits    = new Button (g, 0, 0, 880, 20, 100, 30, "Créditos", "Voltar", color (10,240,0));
  tutorial   = new Button (g, 0, 0, 750, 20, 100, 30, "Tutorial", "Voltar", color (100,240,255));
  tutNext    = new Button (g, 0, 0,(width-wT)/2+wT-80, (height-hT)/2+hT-50, 60, 40, ">>",">>", color (200));
  tutPrev    = new Button (g, 0, 0,(width-wT)/2+80, (height-hT)/2+hT-50, 60, 40, "<<","<<", color (200));

  //FEM Indicator
  indicator = new FEMindicator (Simulation, XOffset[ControlsPG], YOffset[ControlsPG], 164, 376, color(0,40,255), color(255), color(255,40,0), 200, 47);

  //3D
  ffotonN=50;
  eelectronRad = 50;
  ffotonRad = 20;
  eelectron = new Solid (Micro, eelectronRad, 50, 1, 'o');
  eelectron.orbitPath (0, 0, 0, 400,400,400); // Center (x,y,z) Amplitude (x,y,z)
  ffoton = new Solid[ffotonN];
  for (int i=0; i<ffotonN; i++)
  {
    ffoton[i] = new Solid (Micro, ffotonRad, 25, 1, 'F');
    ffoton[i].reset();
  }
  ffotonIndex=0;
  //ffoton.linearPath (0,0,0,50,50,10);

  // DROPDOWN
  DD_h=0;          // drop down heigth
  DD_w=1;
  DD_v=0.2;        // dropping speed
  x   =160;
  y   =10;
  w   =150;
  hmax=90;
  tmax=5000;       // show time in ms
  
  // POWER SAVER
  maxtime=120000;  // Ajuste to tempo limite para entrar no modo de espera 
  lastaction=0;
  standby = loadImage ("sdby.png"); 

  // CREDITS
  plogo = loadImage ("plogo.png");

  background (gBG);
  setText();
  drawTitle();
  
}

void draw ()
{
  println ("("+mouseX+","+mouseY+")");
  
  
  // POWER SAVING
  if (millis()-lastaction>maxtime)
    insuspension=true;
  else
    insuspension=false;
  // ACTION in the end
    
  
  if (!tutorial.isSelected())                                  // When MAIN MODE is SIMULATION in spite of Tutorial
  {
    background(gBG);
    Simulation.background(SimBG);
    Controls.background(ControlsBG);
  
    buildScenario(Simulation);
  
    //WLcor = convert(sourceWL, fotonAlpha);
  
    wlSource.update();
    wlSource.show();                                                                    // display Source's WL slider
    sourceWL = round(map(wlSource.getVal(), 0, wlSource.GetDim('h'), 350, 780));        // updates the Source's WL slidet while gets its value
  
    intensity.update();
    intensity.show();
    fotIntensity = 100/intensity.getVal();                                              //((100-intensity.GetVal())*fotonUniverse/400)+1;
    
    wlCat.update();
    wlCat.show();
    catWL = round(map(wlCat.getVal(), 0, wlSource.GetDim('h'), 350, 780));
    srcColor = convert (catWL, 255);
  
    fem.update();
    fem.show();
    aceleration = fem.getVal()/1000;
  
    indicator.display(fem.getVal());
  
    buildAmp(Simulation);
    buildCathode(Simulation, srcColor);
    Micro.background(10);
    //Micro.background (0.3*red(srcColor), 0.3*green(srcColor), 0.3*blue(srcColor), 120);    uncomment this to see P3D background with the cathode work function energy frequency color
  
    sourceMode.display();
    help.display();
    credits.display();
    fotonModeContinuous = sourceMode.isSelected();
  
    // ====== Start - FOTON CONTROL ======
    
    if (tutWasSelected)    // if simulation has just came back from tutorial, then black 3D screen
    {
      tutOverride=false;
      blackout();
      tutWasSelected=false;
    }
    
    if (fotIntensity <1)                            // Intensity Control Discrete Mode
      foton[millis()%fotonUniverse].trigger();      // && fotIntensity < fotonUniverse/4-1
    else if (millis()%int(fotIntensity)==0 )
    {
      foton[FLastTrig].trigger();
      FLastTrig++;
    }
    if (FLastTrig>=fotonUniverse) FLastTrig=0;      // cicle thru foton objects
  
    for (int i=0; i<foton.length; i++)            // update foton position and color
    {
      foton[i].update();
      foton[i].setWL (sourceWL, fotonAlpha);
    }
  
    WLcor = convert(sourceWL, fotonAlpha);
    if (!fotonModeContinuous)                                                        // Draw light regarding foton mode
    {
      for (int i=0; i<foton.length; i++)
      {
        foton[i].display();
      }
    }
    else
    {
      drawContinuous (Simulation, 60, 12, WLcor, intensity.getVal()*2);
    }
  
    // ====== End - FOTON CONTROL ======
  
  
    //  Start - ELECTRON CONTROL ======
  
    for (int i=0; i<electron.length; i++)                  // updates and shows electron position
    {
      electron[i].update();
      electron[i].display();
    }
    // End - ELECTRON CONTROL 
  
    // ====== Start - Micro 3D CONTROL ======
  
    eelectron.update();
    eelectron.display();
    for (int i=0; i<ffotonN; i++)
    {
      ffoton[i].setWL(sourceWL);
      ffoton[i].update();
      ffoton[i].display();
    }
    //if (frameCount%5==0) ffoton[ffotonIndex].trigger();
  
    if (frameCount%int(fotIntensity*4)==0 )
    {
      ffoton[ffotonIndex].trigger();
      ffotonIndex ++;
    }
  
    //ffotonIndex ++;
    if (ffotonIndex >= ffotonN) ffotonIndex=0;
  
    //println(ffotonIndex);
      
    // ====== End - Micro 3D CONTROL ======
  
    // ====== Start - PGRAPHICS MANAGEMENT ======
  
    image (Controls, XOffset[ControlsPG], YOffset[ControlsPG]);
    image (Simulation, XOffset[SimPG], YOffset[SimPG]);
    image (Micro, XOffset[MicroPG], YOffset[MicroPG]);
  
    // ====== End - PGRAPHICS MANAGEMENT ======
  
  
    dynamicText();
    statusBox();                    // manage status box over graphic
    statusText(statusIndex);        // show text inside status box
    
    // ==== Start - STATUS BAR ====
  
    if (help.isSelected())
    {
      // ==== Start DROP DOWN ====
      if (dropdownTrigger==0)
      {
        dropdownTrigger=6;    // dropdown super activated
        DD_h=0;
      }
  
      statusIndex=0;
      if (mouseX >= XOffset[ControlsPG]+40 && mouseX <= XOffset[ControlsPG]+70 && mouseY >= YOffset[ControlsPG]+80 && mouseY <= YOffset[ControlsPG]+280)
        statusIndex=1;  // SourceWL slider
      if (mouseX >= XOffset[ControlsPG]+210 && mouseX <= XOffset[ControlsPG]+240 && mouseY >= YOffset[ControlsPG]+80 && mouseY <= YOffset[ControlsPG]+280)
        statusIndex=2;  // Cathode color WL slider
      if (mouseX >= XOffset[ControlsPG]+30 && mouseX <= XOffset[ControlsPG]+180 && mouseY >= YOffset[ControlsPG]+315 && mouseY <= YOffset[ControlsPG]+345)
        statusIndex=3; // foton intensity slider
      if (mouseX >= XOffset[ControlsPG]+30 && mouseX <= XOffset[ControlsPG]+180 && mouseY >= YOffset[ControlsPG]+365 && mouseY <= YOffset[ControlsPG]+395)
        statusIndex=4; // fem slider
      if (mouseX >= XOffset[ControlsPG]+140-100 && mouseX <= XOffset[ControlsPG]+140+100 && mouseY >= YOffset[ControlsPG]+445-15 && mouseY <= YOffset[ControlsPG]+445+15)
        statusIndex=5; // foton mode
      if (mouseX >= XOffset[SimPG]+170 && mouseX <= XOffset[SimPG]+170+200 && mouseY >= YOffset[SimPG]+416 && mouseY <= YOffset[SimPG]+416+48)
        statusIndex=6; // fem indicator
  
      temp=sqrt((mouseX-(XOffset[SimPG]+Hsize/2+20))*(mouseX-(XOffset[SimPG]+Hsize/2+20))+(mouseY-(YOffset[SimPG]+Vsize/2))*(mouseY-(YOffset[SimPG]+Vsize/2))); 
      if (temp>=170 && temp<=210)                      // nao me pergunte o porque do +20
          if ( ( mouseY-( float(YOffset[SimPG])+Vsize/2. ) ) / (mouseX- (float(XOffset[SimPG])+Hsize/2.+20.)) >= tan(PI-ang) &&
          (mouseY- (float(YOffset[SimPG])+Vsize/2.)) / (mouseX- (float(XOffset[SimPG])+Hsize/2.+20.) ) <= tan(PI+ang) )
          statusIndex=7;  // cathode
  
      if (temp<=20)
        statusIndex=8; // anode
      if (mouseX >= 5 && mouseX <= 285 && mouseY >= 30+15+Controls.height+20 && mouseY <= 30+15+Controls.height+height-100-Vsize)
        statusIndex=9; // graphic
      if (mouseX >= XOffset[SimPG]+Ox+Hsize/2+Harea*0.62-40 && mouseX <= XOffset[SimPG]+Ox+Hsize/2+Harea*0.62+40 && mouseY >= YOffset[SimPG]+Oy+Varea/2-100 && mouseY <= YOffset[SimPG]+Oy+Varea/2+20)
        statusIndex=10;  // amperimeter
      if (mouseX >= XOffset[MicroPG] && mouseX <= XOffset[MicroPG]+Micro.width && mouseY >= YOffset[MicroPG] && mouseY <= YOffset[MicroPG]+Micro.height)
        statusIndex=11; // Micro PG
    }
    else dropdownTrigger=0;
  
    drawTitle();
    help.display();
    credits.display();
    tutorial.display();
  
    if (dropdownTrigger>0)  // if dropdown is not inactive (0)
    {
      dropdownTrigger=helpDD(dropdownTrigger);
    }
    
    // ==== End - DROP DOWN ====
  
  
    // ==== End - STATUS BAR ====
  
  
    // ==== Graphic ====
  
    drawGraphic(fem.getVal(), wlSource.getVal(), intensity.getVal()); // manage graphic 
  
    // ==== Credits ====  
  
    creditsMode=credits.isSelected();
    if (creditsMode)
    {
      showCredits();
      noLoop();
    }
  }
  
  if (tutorial.isSelected())
  {
    pushMatrix();
    tutorialMode = tutorial(tutorialMode);
    tutorial.display();
    tutNext.display();
    tutPrev.display();
    popMatrix();
    tutWasSelected=true;
  }
  else tutorialMode=1; //!!!
  
  if (insuspension)
    suspend();
  
}


// POWER SAVER SUSPENSION

void suspend()
{
  int h, w;
  float l, fontsize;
  h=320;
  w=400;
  fontsize = 20;
  
  translate ((width-w)/2, (height-h)/2);
  fill (255,225);
  rect (0,0, w, h);
  
  fill(0);
  textAlign(CENTER);
  textFont (verdanab, 20);
  text ("EM ESPERA",w/2, 45);
  image (standby, w/2-100/2, 0.2*h);
  
  textFont (helv, fontsize);
  text ("Esta animação consome recursos do seu \n"+
        "computador e entra em espera após\n"+ round(maxtime/1000) + " segundos\n\n"+ 
        "Aperte qualquer tecla para continuar",w/2, 200);
  
  noLoop();
}

void wake()
{
  insuspension=false;
  loop();
}



// MOUSE INPUT start

void mousePressed()
{
  if (!credits.isSelected() && !tutorial.isSelected())
  {
    sourceMode.mousePressed(mouseX, mouseY);
    help.mousePressed(mouseX, mouseY);
    credits.mousePressed(mouseX, mouseY);
    tutorial.mousePressed(mouseX, mouseY);
  }
  if (tutorial.isSelected())
  {
    tutorial.mousePressed(mouseX, mouseY);
    tutNext.mousePressed(mouseX, mouseY);
    tutPrev.mousePressed(mouseX, mouseY);
  }
  
  lastaction=millis();
  if (insuspension)
    wake();
}

void mouseReleased()
{
  if (credits.isSelected())
  {
    credits.unSelect();
    loop();
    background (gBG);
    drawTitle();
  }
  else
  {
    sourceMode.mouseReleased();
    help.mouseReleased();
    credits.mouseReleased();
    tutorial.mouseReleased();
    tutNext.mouseReleased();
    tutPrev.mouseReleased();
  }
}

// MOUSE INPUT end


// KEYBOARD IMPUT start

void  keyPressed ()
{
  if (key=='1' || key=='z') wlSource.increment(+2);
  if (key=='7' || key=='a') wlSource.increment(-2);
  if (key=='3' || key=='x') wlCat.increment(+2);
  if (key=='9' || key=='s') wlCat.increment(-2);

  if (key=='2' || key=='c') fem.increment (-2);
  if (key=='8' || key=='v') fem.increment (+2);
  if (key=='4' || key=='d') intensity.increment (-2);
  if (key=='6' || key=='f') intensity.increment (+2);

  if (key==ENTER) sourceMode.Select();
  
  lastaction=millis();
  if (insuspension)
    wake();
}

