class Particle
{
  float iniX, iniY, finX, finY, radius, velocity, nextVelocity, x, y;
  float tween, rand, eAng, edgeRad;
  int index;
  color currentColour,nextColour;
  int currentWL, nextWL;
  boolean triggered;
  PGraphics layer;
  char type;
  
  float acel, maxVel;
  
  Particle (PGraphics _layer, float _radius, float _tweenStep, int _index, char _type)
  {
    layer=_layer;
    radius=_radius;
    velocity=_tweenStep;
    nextVelocity=_tweenStep;
    type = _type;
    tween=0;
    edgeRad=catRad-40;
    switch (type){
    case 'f': currentColour = convert(350, fotonAlpha); break;
    case 'e': currentColour = color(240,240,160); break;
    }
    x=0;
    y=0;

    index=_index;
    triggered=false;
    maxVel=5;                        // TO BE CHANGED
  }
  
  void setWL (int _wl, int fAlpha)
  {
    nextWL=_wl;
    nextColour=convert(nextWL, fAlpha);
  }
  void setWL (int _wl)
  {
    nextWL=_wl;
  }
  
  void setVelocity (float _velocity)
  {
    nextVelocity = _velocity;
  }
  
  void setPath (float _iniX, float _iniY, float _finX, float _finY)
  {
    iniX=_iniX;
    iniY=_iniY;
    finX=_finX;
    finY=_finY;
  }
  
  
  void setAngle (float _eAng)
  {
    eAng=_eAng;
  }
  
  void setIndex (int ind)
  {
    index = ind;
  }
  
  void display()
  {
    if (triggered)
    {
      layer.fill (currentColour);
      
      layer.pushMatrix();
      layer.pushStyle();
      layer.noStroke();    
      layer.beginDraw();
      
      layer.translate (x, y);
      //layer.stroke(0,80);
      layer.ellipse (0,0, radius, radius);
      
      layer.endDraw();
      layer.popMatrix();
      layer.popStyle();
    }
    
  }
  
  void update ()
  {
    if (type=='f')
    {
      if (triggered)
      {
        float[] dir = new float[2];
        unit(finX-iniX, finY-iniY, dir);
        
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        
        if (x<finX && x!=0)                     // when foton arrives to the cathode
        {
          this.untrigger();                 // deactivates it
          if (currentWL<catWL)
          {
            electron[index].setAngle(rand);
            electron[index].setWL(currentWL);
            electron[index].trigger();        // activates corresponding electron
          }
        }
      }
    }
    
    if (type=='e')
    {
      if (triggered)
      {
        float[] dir = new float[2];
        unit(finX-iniX, finY-iniY, dir);
        
        
        velocity += aceleration;  
        tween += velocity;
        x = iniX + tween*(dir[0]);
        y = iniY + tween*(dir[1]);
        
        if (x>finX)                     // when electron arrives to the cathode
        {
          untrigger ();                 // deactivates it
        }
        if (x<iniX)
        {
          untrigger ();
        }
      }
    }
  }
  
  void reset ()
  {
    x=0;y=0;
    if (type=='f')              // if particle is a foton
    {
      currentWL    = nextWL;
      currentColour= nextColour;
      velocity     = nextVelocity;
      tween=0;
      rand = random (PI-ang, PI+ang);
      iniX = Ox+0.8*Hsize;
      iniY = Oy+Varea/2+edgeRad*sin(rand)/2;
      finX = Ox+Hsize/2+edgeRad*cos(rand)/2;
      finY = Oy+Varea/2+edgeRad*sin(rand)/2;
    }
    
    if (type=='e')              // if particle is a foton
    {
      //currentColour= nextColour;
      
      //println(nextWL);
      maxVel = map (nextWL, 350, 780, 4.9, 3);
      
      // set initial kinetic energy K = hf-<work function>
      if (index%10==0)
      velocity = maxVel;
      else                            // ensure at least 10% have maximum kinetic energy to create remarkable visual effect
      velocity = random (maxVel/2,maxVel);
      
      tween=0;
      iniX = Ox+Hsize/2+edgeRad*cos(eAng)/2;
      iniY = Oy+Varea/2+edgeRad*sin(eAng)/2;
      finX = Ox+Hsize/2;
      finY = Oy+Varea/2;
    }  
        
  }  
  
  void trigger ()
  {
    if (type=='f') NFtriggered ++;
    if (type=='e') NET++;
    triggered=true;
    reset();
  }
  
  void untrigger ()
  {
    if (type=='f') NFtriggered --;
    if (type=='e') NET --;
    triggered=false;
  }
    
  boolean check ()
  {
  return triggered;
  }

}

void unit(float x, float y, float[] direction)            // calculates path versor to ensure equal speed
{
  float modulo;
  modulo = sqrt(x*x+y*y);
  direction[0] = x/modulo;
  direction[1] = y/modulo;
}

void drawContinuous (PGraphics layer, float dx, float dy, color rawcolour, float colouralpha)        // generates continous light mask
{
  
  layer.tint (rawcolour, colouralpha); 
  layer.beginDraw();
  layer.image (light, dx, dy);
  layer.endDraw();
  layer.noTint();
}

    
    
