  // =====================================================  GUI SLIDER  ============================================================= 
 
class GUIslider        // normal slider 
{
  float XOff, YOff, anchorX, anchorY, LGauge, WGauge, spos, Rmin, Rmax, stdSpos;
  int value, SWidth, SHeight;
  color trackC, gaugeC;
  
  float[] aux;
  color[] palette;
  int wl;
  PGraphics layer;
  boolean over;           // mouse over slider
  boolean locked;
  char bgType;
  
  GUIslider (PGraphics _layer, float _anchorX, float _anchorY, int _SWidth, int _SHeight, float _Rmin, float _Rmax, float _spos, char _type)
  {
    layer   =_layer;
    anchorX =_anchorX;
    anchorY =_anchorY;
    SWidth  =_SWidth;
    SHeight =_SHeight;
    LGauge  = (SWidth<SHeight) ? SWidth : 5;           //gauge vertical dimension
    WGauge  = (SWidth<SHeight) ? 5 : SHeight;            //gauge horizontal dimension
    Rmin    = _Rmin;
    Rmax    = _Rmax;
    spos    = _spos;
    stdSpos = SWidth/2;
    bgType  = _type;
    
    gaugeC = color(200);
    if(bgType=='s')
    trackC = color(150);
    if(bgType=='b')
    trackC = color(50);
    else  // meaning bgType='g'
    trackC = color (150);          // obviamente mudara, ATENCAO AQUI
    
    if (layer==Controls)
    {
      XOff=XOffset[ControlsPG];
      YOff=YOffset[ControlsPG];
    }
    else
    XOff=YOff=0;
    
  }
  
  void show ()
  {
    layer.beginDraw();
    layer.pushMatrix();
    layer.translate (anchorX, anchorY);
    layer.pushStyle();
    
    layer.strokeWeight(4);
    layer.stroke(255);
    layer.line(0, 0, (SWidth>SHeight) ? SWidth : 0, (SWidth>SHeight) ? 0 : SHeight);
    
    layer.strokeWeight(2);
    layer.stroke(trackC);
    layer.line(0, 0, (SWidth>SHeight) ? SWidth : 0, (SWidth>SHeight) ? 0 : SHeight);
    
    
    layer.strokeWeight (1);
    layer.stroke(255);
    if (SWidth>SHeight)
    {layer.line (0, -0.25*SHeight, 0, 0.25*SHeight); layer.line (SWidth, -0.25*SHeight, SWidth, 0.25*SHeight); layer.line (SWidth/2, -0.25*SHeight, SWidth/2, 0.25*SHeight);}
    else
    {layer.line (0, -0.25*SWidth, 0, 0.25*SWidth); layer.line (SHeight, -0.25*SWidth, SHeight, 0.25*SWidth); layer.line (SHeight/2, -0.25*SWidth, SHeight/2, 0.25*SWidth);}
    
    if (SWidth<SHeight) layer.translate (0, spos);
    else layer.translate (spos, 0);
    layer.stroke(0);
    layer.strokeWeight(1);
    layer.strokeJoin(ROUND);
    layer.fill(gaugeC);
    layer.beginShape();
    layer.vertex ( LGauge/2, WGauge/2);
    layer.vertex ( LGauge/2,-WGauge/2);
    layer.vertex (-LGauge/2,-WGauge/2);
    layer.vertex (-LGauge/2, WGauge/2);
    layer.endShape(CLOSE);
    layer.popStyle();
    layer.popMatrix();
    layer.endDraw();
    
    
  }
  
  
  void update() 
  {
 
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }

    if(mousePressed && over && noneLocked()) 
    {
      if (mouseButton == LEFT) locked = true;
      if (mouseButton == RIGHT) spos=stdSpos;
    }
    
    if(!mousePressed) 
    {
      locked = false;
    }
    
    if (locked && SWidth<SHeight)
    {
      spos = (mouseY-anchorY-YOff);
      if (spos<0) spos=0;
      if (spos>SHeight) spos=SHeight;
    }
    if (locked && SWidth>SHeight)
    {
      spos = (mouseX-anchorX-XOff);
      if (spos<0) spos=0;
      if (spos>SWidth) spos=SWidth;
    }

  }
  
  boolean isLocked()
  {
    return locked;
  }  
  
  float getVal ()
  {
    return map(spos, 0, (SWidth>SHeight) ? SWidth : SHeight, Rmin, Rmax);
  }
  
  
  boolean over() 
  {
    if( SWidth<SHeight &&
       mouseX > XOff+anchorX-SWidth/2 && mouseX < XOff+anchorX+SWidth/2 &&
       mouseY > YOff+anchorY && mouseY < YOff+anchorY+SHeight) 
      return true;
    else 
    if ( SWidth>SHeight &&
       mouseX > XOff+anchorX && mouseX < XOff+anchorX+SWidth &&
       mouseY > YOff+anchorY-SHeight/2 && mouseY < YOff+anchorY+SHeight/2) 
      return true;
      
    else
      return false;
  }
  
  int GetDim (char x)
  {
  int dim=0;
  if (x=='h' || x=='w') dim = (x=='h') ?  SHeight : SWidth;
  return dim;
  }
  
  boolean increment (float val)
  {
    if (spos+val >= 0 && spos+val <= SWidth)
    {
      spos +=val;
      return true;
    }
    return false;
  }
} 
  
  // =====================================================  WL SLIDER =============================================================
  
class WLslider  // wavelength slider 
{
  float XOff, YOff, anchorX, anchorY, tri_side, spos;
  int value, SWidth, SHeight;
  
  float[] aux;
  color[] palette;
  int wl;
  PGraphics layer;
  boolean over;           // mouse over slider
  boolean locked;
  char side;
  
  WLslider (PGraphics _layer, float _anchorX, float _anchorY, int _SWidth, int _SHeight, char _side)
  {
    layer=_layer;
    anchorX=_anchorX;
    anchorY=_anchorY;
    SWidth=_SWidth;
    SHeight=_SHeight;
    palette = new color[SHeight+1];
    aux = new float [SHeight+1];
    for (int j=0; j<SHeight; j++)
      {
        wl = (int)(map(j, 0, SHeight, 350, 780));
        palette[j] = convert (wl, 255);
      }
    tri_side = 1.2*SWidth;
    side=_side;
    
    if (layer==Controls)
    {
      XOff=XOffset[ControlsPG];
      YOff=YOffset[ControlsPG];
    }
    else
    XOff=YOff=0;
      
  }
  
  void show ()
  {
    
    layer.beginDraw();
    layer.pushMatrix();
    layer.pushStyle();
    
    
    layer.translate (anchorX, anchorY);
    layer.rect(0, 0, SWidth, SHeight);
    for (int i=0; i<SHeight; i++)
    {
      layer.stroke(palette[i]);
      layer.line (1, i, SWidth-1, i);
    }
    
    layer.translate (0, spos);
    layer.stroke(255);
    layer.strokeWeight(1);
    layer.fill(100);
    //layer.fill(palette[int(spos)]);
    
    if (side=='e')
    {
      layer.beginShape(TRIANGLES);
      layer.vertex (0, 0);
      layer.vertex (-tri_side*sqrt(3)/2, -tri_side/2);
      layer.vertex (-tri_side*sqrt(3)/2, +tri_side/2);
      layer.endShape(CLOSE);
    }
    if (side=='d')
    { 
      layer.translate(SWidth,0);
      layer.beginShape(TRIANGLES);
      layer.vertex (0, 0);
      layer.vertex (tri_side*sqrt(3)/2, -tri_side/2);
      layer.vertex (tri_side*sqrt(3)/2, +tri_side/2);
      layer.endShape(CLOSE);
    }
      
    
    layer.popMatrix();
    layer.popStyle();
    layer.endDraw();
  }
  
  void update() 
  {
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }
    if(mousePressed && over && noneLocked()) 
    {
      if (mouseButton == LEFT) locked = true;
      if (mouseButton == RIGHT) spos=0;
    }
    if(!mousePressed) {
      locked = false;
    }
    
    if (locked)
    {
      spos = (mouseY-anchorY-YOff);
      if (spos<0) spos=0;
      if (spos>SHeight) spos=SHeight;
    }
  }
  
  boolean isLocked()
  {
    return locked;
  }  
  
  float getVal ()
  {
    return (spos);
  }
    

  
  boolean over() 
  {
    if(mouseX > XOff+anchorX && mouseX < XOff+anchorX+SWidth &&
      mouseY > YOff+anchorY && mouseY < YOff+anchorY+SHeight) {
      return true;
    } 
    else {
      return false;
    }
  }
  
  
  int GetDim (char x)
  {
  int dim=0;
  if (x=='h' || x=='w') dim = (x=='h') ?  SHeight : SWidth;
  return dim;
  }
  
  boolean increment (float val)
  {
    if (spos+val >= 0 && spos+val <= SHeight)
    {
      spos +=val;
      return true;
    }
    return false;
  }
  
  void setVal (float val)
  {
    spos = map (val, 0, 100, 0, SHeight);
  }  
}
