String title;
String[] wlSlider=new String[2], hSlider=new String[2];

void setText()
{
  title = "Efeito Fotoelétrico";
  wlSlider[0] = "Seletor da\nFunção Trabalho\ndo Emissor";
  wlSlider[1] = "Seletor de\nCor da Fonte\nLuminosa";
  hSlider[0] = "Intensidade \nLuminosa";
  hSlider[1] = "FEM aplicada";
}

void dynamicText()
{
  fill(255);
  drawLabels();
}

void drawTitle()
{
  pushStyle();
  textFont (verdanab, 20);
  noStroke();
  fill (255);
  rect (5, 5, width-10, 30);
  //textSize(20);
  fill (0,15,210);
  text (title, 370, 30);
  popStyle();
}

void drawLabels()
{
  stroke(255);
  fill(255);
  for (int i=0; i<40; i++)
  {
    line (140, 120+5*i, 140, 121+5*i);
    if (i%5==0) line (135, 120+5*i, 145, 120+5*i);
  }
  line (135,320,145,320);
  pushStyle();
  textFont (helv, 14);
  textAlign(CENTER);
  text (wlSlider[0], 220,70);
  text (wlSlider[1], 60,70);
  textAlign(LEFT);
  text (hSlider[0], 198, 370);
  text (hSlider[1], 198, 425);
  textFont (helv, 12);
  text ("400THz", 92, 325);
  text ("790THz", 92, 125);
  text ("1,65eV", 150, 325);
  text ("3,30eV", 150, 125);
  pushMatrix();
  translate (120,286);
  rotate (-PI/2);
  textFont (verdanab, 12);
  text("FREQUENCIA",20,0);
  text("ENERGIA",35,50);
  popMatrix();
  text("0", 30,350);              // intensity scale labels
  text("100%", 170,350);
  text("-100%", 15,450);          // voltage scale labels
  text("100%", 170,450);
  text("0", 106,450);
  
  fill (240,240,160);
  stroke(240,240,160,180);
  ellipse (320,680,25,25);
  noStroke();
  fill (WLcor);
  ellipse (425,680,15,15);
  fill (255);
  textFont (helv, 13);
  text ("Elétron", 340, 685);
  text ("Fóton", 440, 685);
  
  
  
  textFont (helv, 11);
  text ("Cor\nCorrespondente\nà Função Trabalho", XOffset[SimPG]+Hsize/2-Harea/2+30, YOffset[SimPG]+Vsize/2+Harea/2-69);
  
  
  text ("Câmara de Vácuo", 750, 55);
  text ("Emissor", 420, 90);
  text ("Bateria", 670, 500);
  text ("Circuito", 750, 470);
  text ("Coletor", 615, 240);
  
}

// ==============================================================

// STATUS BOX

void statusBox()
{
  fill(10,20,30);
  noStroke();
  rect (5, 30+15+Controls.height, 280, height-100-Vsize);
  fill(20,20,70);
  rect (5, 30+15+Controls.height, 280, 20);
  textFont (helv, 14);
  fill(255);
  if (help.isSelected())  text ("Modo AJUDA", 10, 30+30+Controls.height);
  else text("Modo GRÁFICO", 10, 30+30+Controls.height);
}

void statusText (int index)
{
  pushStyle();
  fill (255);
  stroke(50,130,255);
  strokeWeight(1);
  textFont (helv, 14);
  if (help.isSelected())
  {
    pushMatrix();
    translate(0,-4);
    if (index>0) line (10, 103+Controls.height, 280, 103+Controls.height);
    switch (index)
    {
    case 0:
      text ("Passe o mouse sobre um item para obter\ninstruções. Passe o mouse sobre esta caixa\npara obter ajuda a respeito do gráfico\nCorrente vs. Voltagem.\n\nItens com ajuda: todos os controladores,\nbotões, emissor, coletor, bateria,\namperímetro, gráfico, janela de visualização\ntridimensional. ", 10, 100+Controls.height);
      break;
    case 1:
      textFont (helv, 13);
      text ("SELETOR DA ENERGIA (ou FREQUÊNCIA) DA\nRADIAÇÃO EMITIDA PELAFONTE LUMINOSA\nControla a energia dos fótons incidentes.\nObserve que se a Função Trabalho do\nmaterial do emissor for superior à energia\ndos fótons incidentes, nenhum elétron será\nliberado da superfície do Emissor.\nTECLADO                             mais = 7 | menos = 1\nCLIQUE ESQUERDO    define cursor\nCLIQUE DIREITO             volta a posição inicial", 10, 100+Controls.height-14);
      break;
    case 2:
      text ("SELETOR DA MAGNITUDE DA\nFUNÇÃO TRABALHO DO EMISSOR\nControla o valor da Função de Trabalho,\nque representa a energia mínima que deve\nser fornecida a um elétron para liberá-lo\nda superfície de um dado material sólido.\n\nTECLADO                            mais = 9 | menos = 3\nCLIQUE ESQUERDO    define cursor\nCLIQUE DIREITO             volta a posição inicial", 10, 100+Controls.height-15);
      break;
    case 3:
      text ("INTENSIDADE LUMINOSA\nEste dimmer controla a intensidade\nda radiação emitida pela fonte luminosa,\ne, consequentemente, a densidade de\nfótons do feixe irradiado.\n\nTECLADO                            menos = 4 | mais = 6\nCLIQUE ESQUERDO   define cursor\nCLIQUE DIREITO            50%", 10, 100+Controls.height);
      break;
    case 4:
      text ("INTENSIDADE DA FEM\nEste dimmer controla o sentido e intensidade\nda Força Eletromotriz (FEM) gerada pela\nbateria. A barra colorida indicada na bateria\nrepresenta a intensidade e o lado positivo[+].\n\nTECLADO                          mais = 8 | menos = 2\nCLIQUE ESQUERDO define cursor\nCLIQUE DIREITO          zera FEM", 10, 100+Controls.height);
      break;
    case 5:
      text ("MODOS DE VISUALIZAÇÃO DA RADIAÇÃO\nEMITIDA PELA FONTE LUMINOSA\nUm clique no botão alterna entre os modos\ndiscreto e contínuo da radiação emitida\npela fonte luminosa.\nO modo contínuo ajuda na visualização dos\nelétrons emitidos.\n\nLIBERADO (default)         modo DISCRETO\nPRESSIONADO                 modo CONTÍNUO\n\nCLIQUE     alterna modo Contínuo/Discreto", 10, 100+Controls.height-15);
      break;
    case 6:
      text ("BATERIA\nEste indicador mostra a intensidade\ne sentido da fem gerada no circuito. A barra\ncolorida indica o pólo positivo da bateria.", 10, 100+Controls.height);
      break;
    case 7:
      text ("EMISSOR\nEste é o Emissor do experimento.\nQuando irradiado com fótons de energia\nsuperior à Função de Trabalho do\nmaterial de que é constituído, emite\nelétrons a partir de sua superfície. Dada\nsua origem física, esses elétrons são\nusualmente denominados Fotoelétrons.", 10, 100+Controls.height);
      break;
    case 8:
      text ("COLETOR\nEste é o Coletor do experimento. Ele\ncoleta os elétrons liberados pelo emissor\ne completa o circuito. Com a ajuda de\num amperímetro, é possível medir a\ncorrente gerada pelos fotoelétrons no\ncircuito.", 10, 100+Controls.height);
      break;
    case 9:
      text ("GRÁFICO CORRENTE VS. VOLTAGEM\nPara os parâmetros definidos pelo usuário,\no gráfico exibe a curva que correlaciona a\ncorrente presente no circuito com a FEM\nimpressa pela bateria. Os eixos auxiliares\nse cruzam no ponto da curva que representa a\nsituação atual. O ponto onde a curva\nintercepta o eixo das voltagens é a\ndenominada \"VOLTAGEM DE CORTE\"  (Vo).", 10, 100+Controls.height);
      break;
    case 10:
      text ("AMPERÍMETRO\nO Amperímetro ilustra a corrente que passa\npelo circuito sob as condições físicas\nselecionadas.O valor dessa corrente\ncorresponde à do regime permanente da\ninteração fóton-elétron, que tem início quando\nos primeiros fótons chegam ao emissor.", 10, 100+Controls.height);
      break;
    case 11:
      text ("VISUALIZAÇÃO TRIDIMENSIONAL\nEsta é uma visualização artística e\ntridimensional da interação fóton-elétron que\nocorre no cátodo. As esferas brancas\nrepresentam os elétrons do emissor e as\nesferas menores coloridas, os fótons\nincidentes.", 10, 100+Controls.height);
      break;
    }
    popMatrix();
  }
  popStyle();
}

